local helper = wesnoth.require "lua/helper.lua"
local T = helper.set_wml_tag_metatable {}
--local debug_utils = wesnoth.require "~add-ons/World_of_Wesnoth/lua/utils.lua"

function wesnoth.level_up(unit)
	-- This function is called by the character menu when the level-up buttons is pressed, returns a new list of properties if advanced and nil of cancelled
	local side_number = wesnoth.get_variable("side_number")
	-- Standard procedure, get the unit, read its properties
	local race, intelligence, strength, dexterity, endurance, total_level, melee_damage, melee_damage_plus, ranged_damage, ranged_damage_plus, melee_precision, ranged_precision, melee_attacks, melee_attacks_plus, ranged_attacks, ranged_attacks_plus, movement, resist_fire, resist_cold, resist_arcane, resist_blade, resist_impact, resist_pierce, skills, specials_melee, specials_ranged, defense, absorb, skills_modified, melee_suck, melee_suck_mana, ranged_suck, ranged_suck_mana, penetrate_fire, penetrate_cold, penetrate_arcane, penetrate_blade, penetrate_impact, penetrate_pierce, magic_damage, melee_type, ranged_type, mana_regen, hitpoints, courage, effects, alignment, class_levels, mana = wesnoth.get_unit_properties(unit)
	-- Race won't change, so we can create a variable holding it properties now
	for j = 1,#races do
		if races[j][2].name == race then
			race_properties = races[j][2]
		end
	end
	-- Initialize some stuff, needed by the GUI
	local race_properties = {}
	local advance_correct = false
	local skill_chosen
	local attribute_chosen
	local class_chosen
	local return_value
	local list_finished
	local dialog = { T.tooltip { id = "tooltip_large" }, T.helptip { id = "tooltip_large" },  maximum_height = 600, maximum_width = 800,
		T.grid { T.row { T.column { T.label { id="title" , definition="title" , label="Level-up"} }} ,
			T.row { T.column { T.scroll_label { id="gui_current_description" , label="                                                                                                                                   \n                                                                                                                                   \n                                                                                                                                   \n"} }} ,
			T.row { T.column { T.grid { T.row {
				T.column { T.grid { 
					T.row { T.column { T.label { label="Choose class to advance to:"} }} ,
					T.row { T.column { horizontal_grow = true, T.listbox { id = "gui_class_chosen", 
						T.list_definition { T.row { T.column { horizontal_grow = true,
							T.toggle_panel { tooltip="You will probably want to advance in the same class as you have advanced before, select another one only if you know what you are doing and know that it will cause a penalty to your character.", T.grid { T.row {
								T.column { T.image { id = "gui_class_icon" } },
			   					T.column { horizontal_alignment = "left", T.label { id = "gui_class_name" } }

							}}}
						}}}
					}}},
					T.row { T.column { T.label { label="Choose attribute to increase:"} }} ,
					T.row { T.column { horizontal_grow = true, T.listbox { id = "gui_attribute_chosen", 
						T.list_definition { T.row { T.column { horizontal_grow = true,
							T.toggle_panel { tooltip="Choose the attribute you want to increase. Read the skill requirements attentively before.", T.grid { T.row {
								T.column { T.image { id = "gui_attribute_icon" } },
			   					T.column { T.grid { 
									T.row { T.column { horizontal_alignment = "left", T.label { id = "gui_attribute_name" } }},
									T.row { T.column { T.grid { T.row {
										T.column { horizontal_alignment = "left", T.label { id = "gui_attribute_value" }},
										T.column { horizontal_alignment = "left", T.label { id = "gui_attribute_importance" }}
									}}}}
								}}
							}}}
						}}}
					}}}
				}},
				T.column { T.grid { 
					T.row { T.column { T.label { label="Choose skill to improve:"} }} ,
					T.row { T.column { T.listbox { id = "gui_skill_chosen", T.list_definition { T.row { T.column { horizontal_grow = true,
						T.toggle_panel { tooltip="Choose the skill you want to improve.", T.grid { T.row {
							T.column { T.image { id = "gui_skill_icon" } },
		   					T.column { T.grid { 
								T.row { T.column { horizontal_alignment = "left", T.label { id = "gui_skill_name" } }},
								T.row { T.column { horizontal_alignment = "left", T.label { id = "gui_skill_level" } }}
							}}
						}}}
					}}}}}}
				}}


			}}}},
			T.row { T.column { T.grid { T.row {
				T.column { T.button { id = "ok", label = "Perform changes" , tooltip="Do all the changes you selected." } },
				T.column { T.button { id = "cancel", label = "Discard changes", tooltip="Undo all selected changes." } }
			}}}}
		}}

	local function preshow()
		local class_chosen_properties
		local issues = {}
		local strength_modified = strength
		local dexterity_modified = dexterity
		local endurance_modified = endurance
		local intelligence_modified = intelligence
		local function setup_attribute_values()
			wesnoth.set_dialog_value(strength_modified .. "   ", "gui_attribute_chosen", 31, "gui_attribute_value")
			wesnoth.set_dialog_value(dexterity_modified .. "   ", "gui_attribute_chosen", 32, "gui_attribute_value")
			wesnoth.set_dialog_value(endurance_modified .. "   ", "gui_attribute_chosen", 33, "gui_attribute_value")
			wesnoth.set_dialog_value(intelligence_modified .. "   ", "gui_attribute_chosen", 34, "gui_attribute_value")
		end
		local function check_skill_requirements()
			-- This function sets up the skill requirements, notes what is available and what is not, and writes the current skill levels
			local related_skills = {}
			-- Writes down the skills of the class being advanced to
			for i=1,100 do
				if skills[i + class_chosen * 100] then
					related_skills[i] = skills[i + class_chosen*100]
				end
			end
			-- Add the racial skills
			local u=17
			for i=1,99 do
				if skills[i] then
					u = u + 1
					related_skills[u] = skills[i]
				end
			end
			-- We must assume that the class being advanced to is one level higher, because the class advancement, attribute advancement and level advancement is done at the same time,
			-- but for requirement purposes, it is assumed that the class is advanced first, then the attribute and finally the skill
			local advanced_class_levels
			if class_levels[class_chosen] then
				advanced_class_level = class_levels[class_chosen] + 1
			else
				advanced_class_level = 1
			end
			local k = 0
			local function check_availability(considered_level,considered_properties,i,p)
				-- Checks if a particular skill is available, considered level is either the class level or the total level in the case of racial skills, considered properties
				-- are a list of skills and other things related to the class or race, i is the position of the skill in the considered_properties table and p is its position on the list
				local current_skill = considered_properties[i][2]
				local can = "yes"
				local function add_issue(issue)
					-- This function is simply to make sure that the list of problems with choosing a skill will not begin or end with a comma, and look like a sentence.
					if can == "yes" then
						can = issue
					else
						can = can .. ", " .. issue
					end
				end
				if related_skills[p] then
					-- This part gets the current level of the skill, shows it under the skill names and block the user from advancing them if they're on maximum level already
					wesnoth.set_dialog_value("Current:" .. related_skills[p] , "gui_skill_chosen", 40 + p , "gui_skill_level")
					if related_skills[p] == 5 then
						add_issue( "Already at maximum level" )
					else
						for j = 1,#considered_properties[i][2] do
							if considered_properties[i][2][j][1] == ("level" .. ( related_skills[p] + 1 )) then
								current_skill = considered_properties[i][2][j][2]
							end
						end
					end
				end
				if current_skill.level then
					-- Checks if the character has a class level high enough to advance get the skill
					if current_skill.level > considered_level then
						add_issue( "level " .. current_skill.level)
					end
				end
				if current_skill.skills then
					-- Checks if the character has at least one point in all required skills. First, the comma-separated list is parsed into a list, then all of them are checked
					-- and then the lacking ones are listed
					for j in string.gmatch( current_skill.skills , "[^%s,][^,]*") do
						if related_skills[tonumber(j)] then
						else
							for k=1,#considered_properties do
								if considered_properties[k][1] == "skill" then
									if tonumber(considered_properties[k][2].number) == tonumber(j) then
										add_issue( considered_properties[k][2].name .. " skill")
									end
								end
							end
						end
					end
				end
				-- Check if attributes are high enough
				if current_skill.strength then
					if current_skill.strength > strength_modified then
						add_issue( current_skill.strength .. " strength")
					end
				end
				if current_skill.dexterity then
					if current_skill.dexterity > dexterity_modified then
						add_issue( current_skill.dexterity .. " dexterity")
					end
				end
				if current_skill.endurance then
					if current_skill.endurance > endurance_modified then
						add_issue( current_skill.endurance .. " endurance")
					end
				end
				if current_skill.intelligence then
					if current_skill.intelligence > intelligence_modified then
						add_issue( current_skill.intelligence .. " intelligence")
					end
				end
				-- And finally writing down if the requirements are met
				if can ~= "yes" then
					if can ~= "Already at maximum level" then
						issues[ p + 40 ] = "Unavailable: requires " .. can
					else
						issues[ p + 40 ] = "Already at maximum level"
					end
					wesnoth.set_dialog_value( "misc/blank-hex.png~BLIT(misc/cross-white.png)" , "gui_skill_chosen", p + 40 , "gui_skill_icon")
				else
					wesnoth.set_dialog_value( "misc/blank-hex.png~BLIT(misc/new-battle.png)" , "gui_skill_chosen", p + 40 , "gui_skill_icon")
					issues[ p + 40 ] = "Available"
				end
			end
			for j=1,#class_chosen_properties do
				-- Computing class skills, so class level and class properties are passed to the function
				if class_chosen_properties[j][1] == "skill" then
					k = k + 1
					check_availability(advanced_class_level,class_chosen_properties,j,k)
				end
			end
			for j = 1,#race_properties do
				-- Computing race skills, so total level and race properties are passed to the function
				if race_properties[j][1] == "skill" then
					k = k + 1
					check_availability(total_level,race_properties,j,k)
				end
			end

		end
		local function check_if_done()
			-- Checks if all mandatory fields are filled
			if class_chosen and attribute_chosen and skill_chosen and issues[skill_chosen] == "Available" then
				wesnoth.set_dialog_active( true, "ok")
				advance_correct = true
			else
				wesnoth.set_dialog_active( false, "ok")
				advance_correct = false
			end
		end
		local function select_class()
			-- If a class is selected, this writes its skills down, with information about them
			class_chosen = wesnoth.get_dialog_value "gui_class_chosen"
			class_chosen_properties = classes[class_chosen][2]
			local k = 41		-- Not sure if starting from field index 41 is necessary, but I think that with this infernally bugged GUI, it worked better like this
			-- First, we clear the former properties
			for i=1,#class_chosen_properties do
				if class_chosen_properties[i][1] == "skill" then
					wesnoth.set_dialog_value( class_chosen_properties[i][2].name , "gui_skill_chosen", k, "gui_skill_name")
					wesnoth.set_dialog_value( "                 " , "gui_skill_chosen", k, "gui_skill_level")
					k = k + 1
				end
			end
			for i=1,#race_properties do
				if race_properties[i][1] == "skill" then
					wesnoth.set_dialog_value( race_properties[i][2].name , "gui_skill_chosen", k, "gui_skill_name")
					wesnoth.set_dialog_value( "                 " , "gui_skill_chosen", k, "gui_skill_level")
					k = k + 1
				end
			end
			check_skill_requirements()
			-- The importance of attributes might change
			for i=31,34 do
				wesnoth.set_dialog_value( "                 " , "gui_attribute_chosen", i , "gui_attribute_importance")
			end
			-- Describe the classes and the importance of attributes. It could be written from data files, but it is one of the oldest things here and I didn't know how to do that back then
			if class_chosen == 1 then
				wesnoth.set_dialog_value("Barbarian is the mighest melee warrior, with almost all abilities related to melee combat. Barbarians can withstand incredible damages and defeat many enemies with brute force. The only magic a Barbarian knows are a few shamanic spells.", "gui_current_description")
				wesnoth.set_dialog_value("Important", "gui_attribute_chosen", 31, "gui_attribute_importance")
				wesnoth.set_dialog_value("Important", "gui_attribute_chosen", 33, "gui_attribute_importance")
			end
			if class_chosen == 2 then
				wesnoth.set_dialog_value("Fencers are agile fighters who prefer dexterity and wit over brute force. Their combat style is based on using dexterity where others use strength. Fencers have also a basic magic training.", "gui_current_description")
				wesnoth.set_dialog_value("Crucial", "gui_attribute_chosen", 32, "gui_attribute_importance")
			end
			if class_chosen == 3 then
				wesnoth.set_dialog_value("Hunters are fighters focused on usage of bows and knowledge of woodlands. Forest is their region, they can control the forces of nature, and their skill with sword can come handy sometimes as well.", "gui_current_description")
				wesnoth.set_dialog_value("Important", "gui_attribute_chosen", 31, "gui_attribute_importance")
				wesnoth.set_dialog_value("Important", "gui_attribute_chosen", 32, "gui_attribute_importance")
			end
			if class_chosen == 4 then
				wesnoth.set_dialog_value("Rogue is the least honest of any fighter a man can find. Poisoning their blades, hiding, attacking from the back and confusing enemies with shadow magic is their favourite combat technique.", "gui_current_description")
				wesnoth.set_dialog_value("Important", "gui_attribute_chosen", 34, "gui_attribute_importance")
				wesnoth.set_dialog_value("Important", "gui_attribute_chosen", 32, "gui_attribute_importance")
			end
			if class_chosen == 5 then
				wesnoth.set_dialog_value("Cleric is a spellcaster whose faith is stronger than anything. Their faith leads them when healing allies, when casting spells, when enchanting allies to fight better, or even when they fight themselves.", "gui_current_description")
				wesnoth.set_dialog_value("Important", "gui_attribute_chosen", 34, "gui_attribute_importance")
				wesnoth.set_dialog_value("Useful", "gui_attribute_chosen", 31, "gui_attribute_importance")
			end
			if class_chosen == 6 then
				wesnoth.set_dialog_value("Wizards are undeniably the strongest spellcasters. They magic is heavily focused on destroying enemies with fire and ice, but they can also cast a few defensive spells." ,"gui_current_description")
				wesnoth.set_dialog_value("Crucial", "gui_attribute_chosen", 34, "gui_attribute_importance")
			end
			if class_chosen == 7 then
				wesnoth.set_dialog_value("Necromancer is a specialist on raising terrible undead armies and crippling enemies with various curses and poisons, with a skeletal figure affecting reistances. Necromancers are specialist spellcasters, and generally weak in melee combat.", "gui_current_description")
				wesnoth.set_dialog_value("Important", "gui_attribute_chosen", 34, "gui_attribute_importance")
				wesnoth.set_dialog_value("Useful", "gui_attribute_chosen", 33, "gui_attribute_importance")
			end
			check_if_done()
		end
		local function select_attribute()
			-- If an attribute is chosen, we have to increase its value in the GUI and check if it will affect the availability of some skills, as well as show a description of the skill
			attribute_chosen = wesnoth.get_dialog_value "gui_attribute_chosen"
			if attribute_chosen == 31 then
				strength_modified = strength + 1
			else
				strength_modified = strength
			end
			if attribute_chosen == 32 then
				dexterity_modified = dexterity + 1
			else
				dexterity_modified = dexterity
			end
			if attribute_chosen == 33 then
				endurance_modified = endurance + 1
			else
				endurance_modified = endurance
			end
			if attribute_chosen == 34 then
				intelligence_modified = intelligence + 1
			else
				intelligence_modified = intelligence
			end
			if attribute_chosen == 31 then
				wesnoth.set_dialog_value("Strength determines the damage a character deals, and the ability to carry heavy armors.", "gui_current_description")
			end
			if attribute_chosen == 32 then
				wesnoth.set_dialog_value("Dexterity determines the chance that the character gets hit, the chance to hit and the damage with ranged weapons.", "gui_current_description")
			end
			if attribute_chosen == 33 then
				wesnoth.set_dialog_value("Endurance determines how many hitpoints the character has.", "gui_current_description")
			end
			if attribute_chosen == 34 then
				wesnoth.set_dialog_value("Intelligence determines the amount of mana (magical power) the character can have.", "gui_current_description")
			end
			if class_chosen_properties then
				check_skill_requirements()
			end
			check_if_done()
			setup_attribute_values()
		end
		local function select_skill()
			skill_chosen = wesnoth.get_dialog_value "gui_skill_chosen"
			-- Describe the skill chosen, write the previously computed reasons why it might be unavailable
			if skill_chosen <= 57 then
				if class_chosen_properties then
					-- We have to verify if the skill is already coded or not, uncoded skills are marked by missing descriptions
					if class_chosen_properties[skill_chosen - 40][2].description then
						wesnoth.set_dialog_value( class_chosen_properties[skill_chosen-40][2].description .. "\n" .. issues[skill_chosen], "gui_current_description")
					else
						wesnoth.set_dialog_value("THIS SKILL IS NOT CODED YET, SO IT WILL HAVE NO EFFECT!\n" .. issues[skill_chosen], "gui_current_description")
					end
				else
					wesnoth.set_dialog_value("No class selected.", "gui_current_description")
				end
			else
				if race_properties then
					wesnoth.set_dialog_value( race_properties[skill_chosen-57][2].description .. "\n" .. issues[skill_chosen], "gui_current_description")
				end
			end
			check_if_done()
		end
		-- Setup some basic things and callbacks
		for i=41,57 do
			wesnoth.set_dialog_value( "                      " , "gui_skill_chosen", i , "gui_skill_name")
			wesnoth.set_dialog_value( "misc/blank-hex.png" , "gui_skill_chosen", i , "gui_skill_icon")
		end
		for i=31,34 do
			wesnoth.set_dialog_value( "                      " , "gui_attribute_chosen", i , "gui_attribute_importance")
		end
		wesnoth.set_dialog_callback(select_class, "gui_class_chosen")
		wesnoth.set_dialog_callback(select_attribute, "gui_attribute_chosen")
		wesnoth.set_dialog_callback(select_skill, "gui_skill_chosen")
		wesnoth.set_dialog_active( false, "ok")
		wesnoth.set_dialog_value("Barbarian", "gui_class_chosen", 1, "gui_class_name")
		wesnoth.set_dialog_value("units/orcs/warrior.png~RC(magenta>black)", "gui_class_chosen", 1, "gui_class_icon")
		wesnoth.set_dialog_value("Fencer", "gui_class_chosen", 2, "gui_class_name")
		wesnoth.set_dialog_value("units/human-loyalists/fencer.png~RC(magenta>blue)", "gui_class_chosen", 2, "gui_class_icon")
		wesnoth.set_dialog_value("Hunter", "gui_class_chosen", 3, "gui_class_name")
		wesnoth.set_dialog_value("units/elves-wood/ranger+female.png~RC(magenta>green)", "gui_class_chosen", 3, "gui_class_icon")
		wesnoth.set_dialog_value("Rogue", "gui_class_chosen", 4, "gui_class_name")
		wesnoth.set_dialog_value("units/human-outlaws/assassin.png~RC(magenta>black)", "gui_class_chosen", 4, "gui_class_icon")
		wesnoth.set_dialog_value("Cleric", "gui_class_chosen", 5, "gui_class_name")
		wesnoth.set_dialog_value("units/human-magi/white-mage.png~RC(magenta>white)", "gui_class_chosen", 5, "gui_class_icon")
		wesnoth.set_dialog_value("Wizard", "gui_class_chosen", 6, "gui_class_name")
		wesnoth.set_dialog_value("units/human-magi/elder-mage.png~RC(magenta>red)", "gui_class_chosen", 6, "gui_class_icon")
		wesnoth.set_dialog_value("Necromancer", "gui_class_chosen", 7, "gui_class_name")
		wesnoth.set_dialog_value("units/undead-necromancers/ancient-lich.png~RC(magenta>black)", "gui_class_chosen", 7, "gui_class_icon")
		wesnoth.set_dialog_value("Strength", "gui_attribute_chosen", 31, "gui_attribute_name")
		wesnoth.set_dialog_value("misc/blank-hex.png", "gui_attribute_chosen", 31, "gui_attribute_icon")
		wesnoth.set_dialog_value("Dexterity", "gui_attribute_chosen", 32, "gui_attribute_name")
		wesnoth.set_dialog_value("misc/blank-hex.png", "gui_attribute_chosen", 32, "gui_attribute_icon")
		wesnoth.set_dialog_value("Endurance", "gui_attribute_chosen", 33, "gui_attribute_name")
		wesnoth.set_dialog_value("misc/blank-hex.png", "gui_attribute_chosen", 33, "gui_attribute_icon")
		wesnoth.set_dialog_value("Intelligence", "gui_attribute_chosen", 34, "gui_attribute_name")
		wesnoth.set_dialog_value("misc/blank-hex.png", "gui_attribute_chosen", 34, "gui_attribute_icon")
		setup_attribute_values()

	end

	local function postshow()
	end

	local choice_done = wesnoth.show_dialog(dialog, preshow, postshow)

	-- Check if some moron pressed Enter even if the Perform Changed button was disabled
	if class_chosen == nil or attribute_chosen == nil or skill_chosen == nil then
		choice_done = -2
	end

	if choice_done == -1 then
		-- If the choice was successful, the class level values, attribute lever values and skill level values are increased or added if necessary
		skill_chosen = skill_chosen - 40 + class_chosen * 100		-- Get the skill code to a more readable value (for the more probable case when it is a class skill)
		attribute_chosen = attribute_chosen - 30
		for l=1,#unit do
			if unit[l][1] == "variables" then
				-- It is needed to check if the skill already has a level set, otherwise it will be added to the list
				local found_class = false
				local found_skill = false
				for k = 1,#unit[l][2] do
					if unit[l][2][k][1] == "a" then
						if tonumber((unit[l][2][k][2].id  - (unit[l][2][k][2].id % 100)) / 100) == tonumber(attribute_chosen) then
							unit[l][2][k][2].id = unit[l][2][k][2].id + 1
						end
						if tonumber(( unit[l][2][k][2].id - 11000 - unit[l][2][k][2].id % 100 ) / 100 ) == tonumber(class_chosen) then
							unit[l][2][k][2].id = unit[l][2][k][2].id + 1
							found_class = true
						end
						if skill_chosen <= 17 + class_chosen * 100 then		-- Checking if it was a class skill or a racial skill, they are saved differently
							if tonumber(( unit[l][2][k][2].id - 20000 - unit[l][2][k][2].id % 10 ) / 10 ) == skill_chosen then
								unit[l][2][k][2].id = unit[l][2][k][2].id + 1
								found_skill = true
							end
						else
							if tonumber(( unit[l][2][k][2].id - 10000 - unit[l][2][k][2].id % 10 ) / 10 ) == race_properties[skill_chosen-17-class_chosen*100][2].number then
								unit[l][2][k][2].id = unit[l][2][k][2].id + 1
								found_skill = true
							end
						end
					end
				end
				-- If they weren't found, they are added at the end of the list
				if found_skill == false then
					if skill_chosen <= 17 + class_chosen * 100 then
						table.insert(unit[l][2],{"a",{id = (skill_chosen * 10 + 20001)}})
					else
						table.insert(unit[l][2],{"a",{id = (race_properties[skill_chosen-17-class_chosen*100][2].number * 10 + 10001)}})
					end
				end
				if found_class == false then
					table.insert(unit[l][2],{"a",{id = (class_chosen * 100 + 11001)}})
				end
				local list = {}
				for p = 1,#unit[l][2] do
					if unit[l][2][p][1] == "a" then
						table.insert(list , unit[l][2][p][2].id)
					end
				end
				list_finished = table.concat(list, ',')
				list_finished = list_finished .. "," .. tostring(4000000 + unit.experience)
			end
		end
	end
	return list_finished
end
