local helper = wesnoth.require "lua/helper.lua"


function wesnoth.set_graphics(unit)
	-- This function sets up appearance for the unit.
	local race, intelligence, strength, dexterity, endurance, total_level, melee_damage, melee_damage_plus, ranged_damage, ranged_damage_plus, melee_precision, ranged_precision, melee_attacks, melee_attacks_plus, ranged_attacks, ranged_attacks_plus, movement, resist_fire, resist_cold, resist_arcane, resist_blade, resist_impact, resist_pierce, skills, specials_melee, specials_ranged, defense, absorb, skills_modified, melee_suck, melee_suck_mana, ranged_suck, ranged_suck_mana, penetrate_fire, penetrate_cold, penetrate_arcane, penetrate_blade, penetrate_impact, penetrate_pierce, magic_damage, melee_type, ranged_type, mana_regen, hitpoints, courage, effects, alignment, class_levels, mana, weapon_type, str_req, int_req, dex_req = wesnoth.get_unit_properties(unit)
	local undead,fairy
	if skills[701] then	-- The Undeath skill makes the unit look undead
		undead = true
	else
		undead = false
	end
	if skills[1] then	-- The elvish only skills adds wings
		fairy = true
	else
		fairy = false
	end
	local skin_tone = ""	-- Elves are a bit whiter than humans, orcs are a bit darker
	if tostring(race) == "elf" then
		skin_tone = "~CS(-20,-20,10)"
	end
	if tostring(race) == "orc" then
		skin_tone = "~CS(20,20,-10)"
	end
	-- Initialization of variables
	local armor = {}
	local hand = {}
	local second_hand = {}
	local bow = {}
	local found_first_hand = false
	-- We need to gather the appearances of items worn
	for i = 1,#unit do
		if unit[i][1] == "variables" then
			for j = 1,#unit[i][2] do
				if unit[i][2][j][1] == "a" then
					-- First handle the case if already a weapon for the right hand was found, if it was done after, it might fire for the same item
					-- Starting with unique items
					if unit[i][2][j][2].id <70000 and unit[i][2][j][2].id >= 60000 then
						local item_code = uniques[unit[i][2][j][2].id-60000][2]
						if ((item_code.sort == "melee" or item_code.sort == "wand") and found_first_hand == true) or item_code.sort == "shield" then
							second_hand.graphics = item_code.graphics or helper.wml_error("Item " .. unit[i][2][j][2].id .. " has no visual appearance assigned.")
							if item_code.sort ~= "shield" then
								second_hand.graphics = second_hand.graphics .. "_left"	-- Left handed weapon
							end
							if item_code.graphics_mod then		-- Graphic mod gives the items interesting colors and other stuff
								second_hand.graphics_mod = item_code.graphics_mod
							else
								second_hand.graphics_mod = ""
							end
						end
					end
					-- Check out magical items
					if unit[i][2][j][2].id <1000000  and unit[i][2][j][2].id >= 200000 then
						local item_code = base_items[((unit[i][2][j][2].id - 200000) % 10000 - (unit[i][2][j][2].id - 200000) % 100)/100][2]
						local suffix,prefix
						local graphics_mod = ""
						-- As in get_unit_properties or describe_item, it has to be cut into prefix, base item and suffix
						if item_code.prefix then
							graphics_mod = item_code.graphics_mod
						end
						if unit[i][2][j][2].id > 210100 then
							if prefixes[(unit[i][2][j][2].id - 200000 - (unit[i][2][j][2].id - 200000) % 10000)/10000][2].graphics_mod then
								graphics_mod = graphics_mod .. prefixes[(unit[i][2][j][2].id - 200000 - (unit[i][2][j][2].id - 200000) % 10000)/10000][2].graphics_mod
							end
						end
						if unit[i][2][j][2].id % 100 > 0 then
							suffix = suffixes[unit[i][2][j][2].id % 100][2]
							if suffixes[unit[i][2][j][2].id % 100][2].graphics_mod then
								graphics_mod = graphics_mod .. suffixes[unit[i][2][j][2].id % 100][2].graphics_mod
							end
						end
						-- We check what is to to know where to save the appearance (order matters)
						if item_code.sort == "armor" then
							armor.graphics = item_code.graphics or helper.wml_error("Item " .. unit[i][2][j][2].id .. " has no visual appearance assigned.")
							armor.graphics_mod = graphics_mod
						end
						if item_code.sort == "bow" then		-- Bows are special, the person will have one displayed only if attacking with a bow
							bow.graphics = item_code.graphics or helper.wml_error("Item " .. unit[i][2][j][2].id .. " has no visual appearance assigned.")
							bow.graphics_mod = graphics_mod
						end
						-- Again, weapon in left hand is checked before the weapon in right hand, so if a weapon is already assigned to the right hand, the second one will go to the left one
						-- Shield can go there too.
						if ((item_code.sort == "melee" or item_code.sort == "wand") and found_first_hand == true) or item_code.sort == "shield" then
							second_hand.graphics = item_code.graphics or helper.wml_error("Item " .. unit[i][2][j][2].id .. " has no visual appearance assigned.")
							if item_code.sort ~= "shield" then
								second_hand.graphics = second_hand.graphics .. "_left"
							end
							second_hand.graphics_mod = graphics_mod
						end
						if (item_code.sort == "melee" or item_code.sort == "wand") and found_first_hand == false then
							hand.graphics = item_code.graphics or helper.wml_error("Item " .. unit[i][2][j][2].id .. " has no visual appearance assigned.")
							hand.graphics_mod = graphics_mod
							found_first_hand = true		-- Another weapon will go into the left hand
						end
					end
					-- Handling unique items, those that won't be assigned into the left hand
					if unit[i][2][j][2].id <70000  and unit[i][2][j][2].id >= 60000 then
						local item_code = uniques[unit[i][2][j][2].id-60000][2]
						if item_code.sort == "armor" then
							armor.graphics = item_code.graphics or helper.wml_error("Item " .. unit[i][2][j][2].id .. " has no visual appearance assigned.")
							if item_code.graphics_mod then
								armor.graphics_mod = item_code.graphics_mod
							else
								armor.graphics_mod = ""
							end
						end
						if item_code.sort == "bow" then
							bow.graphics = item_code.graphics or helper.wml_error("Item " .. unit[i][2][j][2].id .. " has no visual appearance assigned.")
							if item_code.graphics_mod then
								bow.graphics_mod = item_code.graphics_mod
							else
								bow.graphics_mod = ""
							end
						end
						if (item_code.sort == "melee" or item_code.sort == "wand") and found_first_hand == false then
							hand.graphics = item_code.graphics or helper.wml_error("Item " .. unit[i][2][j][2].id .. " has no visual appearance assigned.")
							if item_code.graphics_mod then
								hand.graphics_mod = item_code.graphics_mod
							else
								hand.graphics_mod = ""
							end
							found_first_hand = true
						end
					end
				end
			end
		end
	end
	-- We need some defaults, the character should not run around half-naked or some players might prefer to walk around with their intentionally unarmored heroines and get slain
	if not armor.graphics then
		armor.graphics = "character/armor/robe"
		armor.graphics_mod = ""
	end
	if not bow.graphics then
		bow.graphics = "character/weapons/bow"
		bow.graphics_mod = ""
	end
	if not hand.graphics then
		hand.graphics = "character/weapons/sword"
		hand.graphics_mod = ""
	end
	if not second_hand.graphics then
		second_hand.graphics = "character/armor/shield"
		second_hand.graphics_mod = ""
	end
	local function generate_frame(suffix)
		-- In an animation, the image names will be just the original name with a suffix before the .png ending, so we can use one function to generate them.
		if not suffix then
			suffix = ""
		end
		local image = "character/base/base"
		if fairy then	-- Fairy wings go behind the body
			image = "character/base/faerie-wings.png~BLIT(" .. image
		end
		if race == "elf" and unit.gender == "female" and not undead then	-- Female elves have long hair visible behind their body
			image = "character/base/elf-hair-female.png~BLIT(" .. image
		end
		-- Females and undead have different bodies
		if unit.gender == "female" then
			image = image .. "-female"
		end
		if undead then
			image = image .. "-undead"
		end
		image = image .. suffix .. ".png".. skin_tone
		-- Close the possibly opened brackets
		if fairy then
			image = image .. ")"
		end
		if race == "elf" and unit.gender == "female" and not undead then
			image = image .. ")"
		end
		image = image .. "~BLIT(" .. armor.graphics
		if unit.gender == "female" or undead then	-- Females have different graphics for armours, undead too, because they have no muscles
			image = image .. "-female"
		end
		image = image .. suffix .. ".png" .. armor.graphics_mod .. ")"
		-- Each race and gender has its own head
		local head = "character/base/human"
		if tostring(race) == "elf" then
			head = "character/base/elf"
		end
		if tostring(race) == "orc" then
			head = "character/base/orc"
		end
		if unit.gender == "female" then
			head = head .. "-female"
		end
		if undead then		-- Undead head is genderless, it is hard to tell a male skull from a female one if it is 10 pixels large
			head = "character/base/undead"	
		end
		-- And weapons
		image = image .. "~BLIT(" .. head .. suffix .. ".png" .. ")"
		image = image .. "~BLIT(" .. hand.graphics .. suffix .. ".png" .. hand.graphics_mod .. ")"
		image = image .. "~BLIT(" .. second_hand.graphics .. suffix .. ".png" .. second_hand.graphics_mod .. ")"
		return image
	end
	local function generate_frame_archery(count)
		-- This is basically a clone of generate_frame, but for archery, where the unit holds only the bow and not the weapons
		if not suffix then
			suffix = ""
		end
		local image = "character/base/base"
		if fairy then
			image = "character/base/faerie-wings.png~BLIT(" .. image
		end
		if race == "elf" and unit.gender == "female" and not undead then
			image = "character/base/elf-hair-female.png~BLIT(" .. image
		end
		if unit.gender == "female" then
			image = image .. "-female"
		end
		if undead then
			image = image .. "-undead"
		end
		image = image .. "-ranged-" .. tostring(count) .. ".png".. skin_tone	-- Ranged animation sprites will be named like ranged-1 etc.
		if fairy then
			image = image .. ")"
		end
		if race == "elf" and unit.gender == "female" and not undead then
			image = image .. ")"
		end
		image = image .. "~BLIT(" .. armor.graphics
		if unit.gender == "female" or undead then
			image = image .. "-female"
		end
		image = image .. "-ranged-" .. tostring(count) .. ".png" .. armor.graphics_mod .. ")"
		local head = "character/base/human"
		if tostring(race) == "elf" then
			head = "character/base/elf"
		end
		if tostring(race) == "orc" then
			head = "character/base/orc"
		end
		if unit.gender == "female" then
			head = head .. "-female"
		end
		if undead then
			head = "character/base/undead"	
		end
		image = image .. "~BLIT(" .. head .. suffix .. ".png" .. ")"
		image = image .. "~BLIT(" .. bow.graphics .. "-ranged-" .. tostring(count) .. ".png" .. hand.graphics_mod .. ")"
		return image
	end
	for i = 1,#unit do
		if unit[i][1] == "modifications" then
			unit[i][2][#unit[i][2]+1] = { "advance" , {
				-- Because we don't have too many frames now, we will just use the ~BLIT trick on all frames using the blank-hex to make it look normal
				name = "character_graphics" ,
				{ "effect" , {
					apply_to = "image_mod" ,
					add = "BLIT(" .. generate_frame("") .. ")"
				}}--,
				-- For unknown reasons, wesnoth engine messes this up, probably wesnoth.put_unit lacks some internal event hook
--				{ "effect" , {
--					apply_to = "new_animation" ,
--					{ "standing_anim" , {
--						{ "frame" , {
--							duration = 50 ,
--							image = generate_frame("")
--						}}
--					}}
--				}}

			}}

		end
		if unit[i][1] == "variables" then
			-- I find it useful to save the baseframe somewhere
			unit[i][2].baseframe = generate_frame("")
		end
	end

	return unit
end

function wesnoth.wml_actions.animate_missile(cfg)
	-- A shot that explodes on target, can be also without the shot or without the explosion. This is quite simple, just to shorten the WML codes that would be necessary for this.
	local target = {}
	for i = 1,#cfg do
		if #cfg[i] > 0 then
			if cfg[i][1] == "target" then
				target = cfg[i][2]
			end
		end
	end
	if (not target.x) or (not target.y) then helper.wml_error("[animate_missile] lacks the [target] coordinates.") end	-- We must know where it is flying
	if cfg.missile_unit then
		local source = {}
		for i = 1,#cfg do
			if #cfg[i] > 0 then
				if cfg[i][1] == "source" then
					source = cfg[i][2]
				end
			end
		end
		if (not source.x) or (not source.y) then helper.wml_error("[animate_missile] lacks the [source] coordinates that are needed if a missile is used.") end		-- If there is a shot, its caster must be known
		local modifications = {}
		-- We should be able to simply colorize the unit that represents the missile
		if cfg.missile_graphic_mod then
			modifications = { "modifications" , {
					{ "advance" , {
						{ "effect" , {
							apply_to="image_mod",
							add=cfg.missile_graphic_mod
						}}
					}}
				}}
		end
		-- The missile is a classical unit, that is created, moved to target and killed, its movement_anims handle its appearance
		if #modifications > 0 then
			wesnoth.wml_actions.unit{ id="special_unit_missile", type = cfg.missile_unit , x = source.x, y = source.y , modifications}
		else
			wesnoth.wml_actions.unit{ id="special_unit_missile", type = cfg.missile_unit , x = source.x, y = source.y}
		end
		wesnoth.wml_actions.move_unit{ id="special_unit_missile", to_x=target.x , to_y=target.y, fire_event=false}
		wesnoth.wml_actions.kill{ id="special_unit_missile", fire_event=false }
	end
	-- The explosion is a sequence of [item]s put and removed from the ground, with some delays and possibly sounds between them
	local explosion = {}
	for i = 1,#cfg do
		if #cfg[i] > 0 then
			if cfg[i][1] == "explosion" then
				explosion = cfg[i][2]
			end
		end
	end
	if explosion then
		for i = 1,#explosion do
			if #explosion[i] > 0 then
				if explosion[i][1] == "frame" then
					if explosion[i][2].image then
						wesnoth.wml_actions.item({ x=target.x , y=target.y, halo=explosion[i][2].image, image="misc/blank-hex.png"})
					end
					if explosion[i][2].sound then
						wesnoth.wml_actions.sound({ name=explosion[i][2].sound})
					end
					if explosion[i][2].duration then
						wesnoth.wml_actions.delay({ time=explosion[i][2].duration})
					end
					if explosion[i][2].image then
						wesnoth.wml_actions.remove_item({ x=target.x , y=target.y, image="misc/blank-hex.png"})
					end
				end
			end
		end
	end
end
