local helper = wesnoth.require "lua/helper.lua"
local T = helper.set_wml_tag_metatable {}
-- local debug_utils = wesnoth.require "~add-ons/World_of_Wesnoth/lua/utils.lua"

function wesnoth.setup_spells_descriptions(skills,magic_damage)
	-- This function gets access to the skill table of the character and magic_damage attribute, and generates a table containing information about all spells available
	local spells_names = {}
	local spells_costs = {}
	local spells_descriptions = {}
	local spells_names_ingame = {}
	local enchantment_cost = {}
	local summon = {}
	local fire_mastery = 0
	local cold_mastery = 0
	if skills.sill_617 then
		fire_mastery = 15 * skills.sill_617
	end
	if skills.sill_616 then
		cold_mastery = 15 * skills.sill_616
	end
	if skills.skill_104 then
		spells_names[104] = "spiritual_strike"
		spells_costs[104] = 4
		spells_descriptions[104] = "Deals " .. tostring((7 + 2 * (skills.skill_104 + skills.skill_104 ^ 2))*(1 + magic_damage/100)) .. " arcane damage to a single target."
		spells_names_ingame[104] = "Spiritual Strike"
		enchantment_cost[104] = 0	-- Isn't an enchantment
		summon[104] = 0			-- Isn't a summon
	end
	if skills.skill_107 then
		spells_names[107] = "spiritual_recovery"
		spells_costs[107] = 8 + skills.skill_107
		spells_descriptions[107] = "Recovers " .. tostring(15 + skills.skill_107 * 10) .. "% hitpoints (self only)."
		spells_names_ingame[107] = "Spiritual Recovery"
		enchantment_cost[107] = 0
		summon[107] = 0
	end
	if skills.skill_112 then
		spells_names[112] = "ancestor_guardian"
		spells_costs[112] = 4
		spells_descriptions[112] = "Summons a spiritual warrior to fight on your side"
		spells_names_ingame[112] = "Ancestor Guardian"
		enchantment_cost[112] = 1	-- Means that keeping him summoned costs 1 mana per turn
		summon[112] = 1			-- Means that only 1 ancestor guardian can be summoned
	end
	if skills.skill_116 then
		spells_names[116] = "incarnation_of_odin"
		spells_costs[116] = 0
		spells_descriptions[116] = "Adds " .. tostring((4 + skills.skill_116 * 4)*(1 + magic_damage/100)) .. " arcane damage to each hit with any melee attack, and heals " .. tostring((skills.skill_116 * 2)) .. "damage from each hit taken."
		spells_names_ingame[116] = "Incatnation of Odin"
		enchantment_cost[116] = 1
		summon[116] = 0
	end
	if skills.skill_203 then
		spells_names[203] = "flaming_weapon"
		spells_costs[203] = 0
		spells_descriptions[203] = "Adds " .. tostring((4 + skills.skill_203 ^2)*(1 + (magic_damage + fire_mastery)/100)) .. " fire damage to each hit with any melee attack."
		spells_names_ingame[203] = "Flaming Weapon"
		enchantment_cost[203] = 1
		summon[203] = 0
	end
	if skills.skill_208 then
		spells_names[208] = "fireball"
		spells_costs[208] = 5
		spells_descriptions[208] = "Deals " .. tostring((7 + 2 * (skills.skill_208 ^ 2 + skills.skill_208 * 2 ))*(1 + (magic_damage + fire_mastery)/100)) .. " fire damage to the target and a half of it to all enemies adjacent to it."
		spells_names_ingame[208] = "Fireball"
		enchantment_cost[208] = 0
		summon[208] = 0
	end
	if skills.skill_211 then
		spells_names[211] = "magical recovery"
		spells_costs[211] = 6
		spells_descriptions[211] = "Recovers " .. tostring(50 + skills.skill_211 * 25) .. " hitpoints."
		spells_names_ingame[211] = "Magical Recovery"
		enchantment_cost[211] = 0
		summon[211] = 0
	end
	if skills.skill_214 then
		spells_names[214] = "doppelganger"
		spells_costs[214] = 9
		spells_descriptions[214] = "Summons a duplicate of self as a loyal servant"
		spells_names_ingame[214] = "Doppelganger"
		enchantment_cost[214] = 1
		summon[214] = 1
	end
	if skills.skill_216 then
		spells_names[216] = "shroud_of_flame"
		spells_costs[216] = 0
		spells_descriptions[216] = "Deals " .. tostring((4 + skills.skill_203 ^2)*(1 + (magic_damage + fire_mastery)/100)) .. " fire damage who hit the target with this enchantment."
		spells_names_ingame[216] = "Shroud of Flame"
		enchantment_cost[216] = 1
		summon[216] = 0
	end
	if skills.skill_301 then
		spells_names[301] = "long_range_shot"
		spells_costs[301] = 1
		spells_descriptions[301] = "Hits with the ranged attack for " .. tostring(100*(0.45 + 0.15 * skills.skill_301)) .. "% of original total damage damage with 70% chance to hit."
		spells_names_ingame[301] = "Long Range Shot"
		enchantment_cost[301] = 0
		summon[301] = 0
	end
	if skills.skill_303 then
		spells_names[303] = "leeches"
		spells_costs[303] = 0
		spells_descriptions[303] = "Drains " .. tostring((4 + 2*skills.skill_303)*(1 + magic_damage/100)) .. " hitpoints from every adjacent unit to the target, healing the target."
		spells_names_ingame[303] = "Leeches"
		enchantment_cost[303] = 1
		summon[303] = 0
	end
	if skills.skill_305 then
		spells_names[305] = "animal_follower"
		spells_costs[305] = 5
		spells_descriptions[305] = "Summons an animal follower to fight on your side."
		spells_names_ingame[305] = "Animal Follower"
		enchantment_cost[305] = 1
		summon[305] = 1
	end
	if skills.skill_311 then
		spells_names[311] = "synthesis"
		spells_costs[311] = 3
		spells_descriptions[311] = "Recovers " .. tostring(25 + skills.skill_311 * 25) .. " hitpoints."
		spells_names_ingame[311] = "Synthesis"
		enchantment_cost[311] = 0
		summon[311] = 0
	end
	if skills.skill_312 then
		spells_names[312] = "plant_growth"
		spells_costs[312] = 5
		spells_descriptions[312] = "All enemies within range of " .. tostring(skills.skill_312) .. " hexes lose their ZoC for 5 turns in average."
		spells_names_ingame[312] = "Plant Growth"
		enchantment_cost[312] = 0
		summon[312] = 0
	end
	if skills.skill_316 then
		spells_names[316] = "earthquake"
		spells_costs[316] = 11
		spells_descriptions[316] = "All enemies within range of 3 hexes take " .. tostring((22 + 3 * skills.skill_316 ^ 2)*(1 + magic_damage/100)) .. " impact damage."
		spells_names_ingame[316] = "Earthquake"
		enchantment_cost[316] = 0
		summon[316] = 0
	end
	if skills.skill_403 then
		spells_names[403] = "summon_shadow"
		spells_costs[403] = 5
		spells_descriptions[403] = "Summons a shadow to fight on your side."
		spells_names_ingame[403] = "Summon Shadow"
		enchantment_cost[403] = 1
		summon[403] = 1
	end
	if skills.skill_406 then
		spells_names[406] = "toxic_cloud"
		spells_costs[406] = 6
		spells_descriptions[406] = "Poisons all enemies in range" .. tostring(skills.skill_406) .. "hexes from the main target. Cooldown 2 turns."
		spells_names_ingame[406] = "Toxic Cloud"
		enchantment_cost[406] = 0
		summon[406] = 0
	end
	if skills.skill_408 then
		spells_names[408] = "shadow_blast"
		spells_costs[408] = 5
		spells_descriptions[408] = "Deals " .. tostring((7 + 2 * (skills.skill_408 + skills.skill_408 ^ 2))*(1 + magic_damage/100)) .. " arcane damage to a single target, draining back a half of it."
		spells_names_ingame[408] = "Shadow Blast"
		enchantment_cost[408] = 0
		summon[408] = 0
	end
	if skills.skill_411 then
		spells_names[411] = "fleeing"
		spells_costs[411] = 5
		spells_descriptions[411] = "Restores/adds " .. tostring(4 + 2 * skills.skill_411) .. " movement points."
		spells_names_ingame[411] = "Fleeing"
		enchantment_cost[411] = 0
		summon[411] = 0
	end
	if skills.skill_412 then
		spells_names[412] = "invisibility"
		spells_costs[412] = 11 - skills.skill_412
		spells_descriptions[412] = "Target becomes invisible, the invisibility will temporarily vanish after attacking."
		spells_names_ingame[412] = "Fleeing"
		enchantment_cost[412] = 0
		summon[412] = 0
	end
	if skills.skill_416 then
		spells_names[416] = "shadow_explosion"
		spells_costs[416] = 12
		spells_descriptions[416] = "Deals " .. tostring((12 + 2 * (skills.skill_416 + skills.skill_416 ^ 2))*(1 + magic_damage/100)) .. " arcane damage to targets within a range of 2 hexes, and the caster heals the amount of hitpoints the targets that were killed by this spell took."
		spells_names_ingame[416] = "Shadow Explosion"
		enchantment_cost[416] = 0
		summon[416] = 0
	end
	if skills.skill_502 then
		spells_names[502] = "divine_might"
		spells_costs[502] = 0
		spells_descriptions[502] = "Adds " .. tostring((10 + skills.skill_502 * 10)*(1 + magic_damage/100)) .. "% of original melee attacks' damage as arcane damage."
		spells_names_ingame[502] = "Divine Might"
		enchantment_cost[502] = 2
		summon[502] = 0
	end
	if skills.skill_503 then
		spells_names[503] = "lightbeam"
		spells_costs[503] = 6
		spells_descriptions[503] = "Deals " .. tostring((10 + 3 * (skills.skill_503 + skills.skill_503 ^ 2))*(1 + magic_damage/100)) .. " arcane damage to a single target."
		spells_names_ingame[503] = "Spiritual Strike"
		enchantment_cost[503] = 0
		summon[503] = 0
	end
	if skills.skill_504 then
		spells_names[504] = "heal"
		spells_costs[504] = 9
		spells_descriptions[504] = "Recovers " .. tostring(15 + skills.skill_504 ^ 2 * 10) .. " hitpoints."
		spells_names_ingame[504] = "Heal"
		enchantment_cost[504] = 0
		summon[504] = 0
	end
	if skills.skill_507 then
		spells_names[507] = "holy_armor"
		spells_costs[507] = 0
		spells_descriptions[507] = "Heaks " .. tostring(7 + skills.skill_507 * 3) .. "% of damage taken by normal means."
		spells_names_ingame[507] = "Holy Armor"
		enchantment_cost[507] = 1
		summon[507] = 0
	end
	if skills.skill_508 then
		spells_names[508] = "divine_blast"
		spells_costs[508] = 11
		spells_descriptions[508] = "Deals " .. tostring(24*(1 + magic_damage/100)) .. " arcane damage to enemies in range of " .. tostring(skills.skill_508) .. " hexes."
		spells_names_ingame[508] = "Divine Blast"
		enchantment_cost[508] = 0
		summon[508] = 0
	end
	if skills.skill_509 then
		spells_names[509] = "magical_mirror"
		spells_costs[509] = 0
		spells_descriptions[509] = "Returns " .. tostring(30 + skills.skill_509 * 10) .. "% of fire, cold and arcane damage back to attackers."
		spells_names_ingame[509] = "Magical Mirror"
		enchantment_cost[509] = 1
		summon[509] = 0
	end
	if skills.skill_510 then
		spells_names[510] = "searing_light"
		spells_costs[510] = 12
		spells_descriptions[510] = "Deals " .. tostring((30 + 6 * skills.skill_510 ^ 2) * (1 + (magic_damage + fire_mastery)/100)) .. " fire damage to enemies in range of 1 hex."
		spells_names_ingame[510] = "Searing Light"
		enchantment_cost[510] = 0
		summon[510] = 0
	end
	if skills.skill_511 then
		spells_names[511] = "blessing"
		spells_costs[511] = 0
		spells_descriptions[511] = "Heals " .. tostring(10 + skills.skill_511 * 5) .. "% of maximum hitpoints per turn."
		spells_names_ingame[511] = "Blessing"
		enchantment_cost[511] = 2
		summon[511] = 0
	end
	if skills.skill_512 then
		spells_names[512] = "summon_messenger"
		spells_costs[512] = 10
		spells_descriptions[512] = "Summons a powerful creature of Light to help."
		spells_names_ingame[512] = "Summons Messenger"
		enchantment_cost[512] = 1
		summon[512] = 1
	end
	if skills.skill_514 then
		spells_names[514] = "divine_wrath"
		spells_costs[514] = 14
		spells_descriptions[514] = "Deals " .. tostring((10 + 2 * skills.skill_513 ^ 2) * (1 + magic_damage/100)) .. " fire, cold and arcane damage to enemies in range of 2 hexes."
		spells_names_ingame[514] = "Divine Wrath"
		enchantment_cost[514] = 0
		summon[514] = 0
	end
	if skills.skill_516 then
		spells_names[516] = "restoration"
		spells_costs[516] = 12
		spells_descriptions[516] = "Recovers " .. tostring(25 + skills.skill_516 * 15) .. "% hitpoints to the target."
		spells_names_ingame[516] = "Restoration"
		enchantment_cost[516] = 0
		summon[516] = 0
	end
	if skills.skill_517 then
		spells_names[517] = "armageddon"
		spells_costs[517] = 12
		spells_descriptions[517] = "Deals " .. tostring((12 + 3 * skills.skill_517 ^ 2) * (1 + (magic_damage + fire_mastery)/100)) .. " fire and impact damage to enemies in range of 3 hexes. Cooldown 2 turns"
		spells_names_ingame[517] = "Armageddon"
		enchantment_cost[517] = 0
		summon[517] = 0
	end
	if skills.skill_601 then
		spells_names[601] = "steel_skin"
		spells_costs[601] = 0
		spells_descriptions[601] = "Returns and heals back " .. tostring(7 + skills.skill_601 * 3) .. "% of blade, pierce and impact damage taken."
		spells_names_ingame[601] = "Steel Skin"
		enchantment_cost[601] = 2
		summon[601] = 0
	end
	if skills.skill_603 then
		spells_names[603] = "freezing_bolt"
		spells_costs[603] = 5
		spells_descriptions[603] = "Deals " .. tostring((7 + 2 * (skills.skill_603 + skills.skill_603 ^ 2))*(1 + (magic_damage + cold_mastery)/100)) .. " cold damage to a single target, slowing it."
		spells_names_ingame[603] = "Freezing Bolt"
		enchantment_cost[603] = 0
		summon[603] = 0
	end
	if skills.skill_604 then
		spells_names[604] = "inferno"
		spells_costs[604] = 5
		spells_descriptions[604] = "Deals " .. tostring((11 + 3 * (skills.skill_604 + skills.skill_604 ^ 2))*(1 + (magic_damage + fire_mastery)/100)) .. " fire damage to a single target, poisoning it."
		spells_names_ingame[604] = "Freezing Bolt"
		enchantment_cost[604] = 0
		summon[604] = 0
	end
	if skills.skill_607 then
		spells_names[607] = "create_golem"
		spells_costs[607] = 5
		spells_descriptions[607] = "Creates a golem to fight on your side."
		spells_names_ingame[607] = "Create Golem"
		enchantment_cost[607] = 1
		summon[607] = 1
	end
	if skills.skill_608 then
		spells_names[608] = "grimcold_blast"
		spells_costs[608] = 11
		spells_descriptions[608] = "Deals " .. tostring((4 + 3 * (skills.skill_608 + skills.skill_608 ^ 2))*(1 + (magic_damage + cold_mastery)/100)) .. " cold damage and " .. tostring((8 + (skills.skill_608 + skills.skill_608 ^ 2))*(1 + magic_damage/100)) .. " arcane damage to target in a 1-hex range, healing a half of the damage dealt. Can drain also undead."
		spells_names_ingame[608] = "Grimcold blast"
		enchantment_cost[608] = 0
		summon[608] = 0
	end
	if skills.skill_611 then
		spells_names[611] = "chilling_beam"
		spells_costs[611] = 16 - skills.skill_611 * 2
		spells_descriptions[611] = "Deals " .. tostring((2 + 3 * (skills.skill_611 + skills.skill_611 ^ 2))*(1 + (magic_damage + cold_mastery)/100)) .. " cold damage to the target, and slows it for 8 turns in average."
		spells_names_ingame[611] = "Chilling Beam"
		enchantment_cost[611] = 0
		summon[611] = 0
	end
	if skills.skill_613 then
		spells_names[613] = "meteor_storm"
		spells_costs[613] = 12
		spells_descriptions[613] = "Deals " .. tostring((24 + 2 * (skills.skill_613 + skills.skill_613 ^ 2))*(1 + (magic_damage + fire_mastery)/100)) .. " fire damage to all targets in the range of 3 hexes. Cooldown 2 turns."
		spells_names_ingame[613] = "Meteor Storm"
		enchantment_cost[613] = 0
		summon[613] = 0
	end
	if skills.skill_615 then
		spells_names[615] = "freezing armor"
		spells_costs[615] = 0
		spells_descriptions[615] = "Slows all adjacent units and deals " .. tostring(2 * skills.skill_615 ^2 - 1) .. " cold damage."
		spells_names_ingame[615] = "Freezing Armor"
		enchantment_cost[615] = 1
		summon[615] = 0
	end
	if skills.skill_702 then
		spells_names[702] = "summon_skeleton"
		spells_costs[702] = 7
		spells_descriptions[702] = "Creates a skeleton to fight on your side. Maximum number of skeletons is " .. tostring(skills.skill_702) .. "."
		spells_names_ingame[702] = "Summon Skeleton"
		enchantment_cost[702] = 0
		summon[702] = skills.skill_702
	end
	if skills.skill_703 then
		spells_names[703] = "dark_blast"
		spells_costs[703] = 6
		if skills.skill_703 == 1 then
			spells_descriptions[703] = "Deals 18 arcane damage to a single target, draining back a half of it."
		else
			spells_descriptions[703] = "Deals 18 arcane damage to a group of targets in the range of " .. tostring(skills.skill_703-1) .. " hexes from the main target, draining back a half of it."
		end
		spells_names_ingame[703] = "Dark Blast"
		enchantment_cost[703] = 0
		summon[703] = 0
	end
	if skills.skill_704 then
		spells_names[704] = "foul_cloak"
		spells_costs[704] = 0
		if skills.skill_717 then
			spells_descriptions[704] = "Adds a poison that deals " .. tostring((1 + skills.skill_704 + skills.skill_717)*8) .. " damage per turn (lasts for 8 turns in average) to melee attacks."
		else
			spells_descriptions[704] = "Adds a poison that deals " .. tostring((1 + skills.skill_704) * 8) .. " damage per turn (lasts for 8 turns in average) to melee attacks."
		end
		spells_names_ingame[704] = "Foul Cloak"
		enchantment_cost[704] = 1
		summon[704] = 0
	end
	if skills.skill_705 then
		spells_names[705] = "freezing_wave"
		spells_costs[705] = 10
		spells_descriptions[705] = "Deals " .. tostring((7 + 2 * (skills.skill_705 + skills.skill_705 ^ 2))*(1 + (magic_damage + cold_mastery)/100)) .. " cold damage to a group of targets within the range of 1 hex, slowing them."
		spells_names_ingame[705] = "Freezing Wave"
		enchantment_cost[705] = 0
		summon[705] = 0
	end
	if skills.skill_706 then
		spells_names[706] = "summon_skeletal_archer"
		spells_costs[706] = 8
		spells_descriptions[706] = "Creates a skeletal archer to fight on your side. Maximum number of skeletal archers is " .. tostring(skills.skill_706) .. "."
		spells_names_ingame[706] = "Summon Skeletal Archer"
		enchantment_cost[706] = 0
		summon[706] = skills.skill_706
	end
	if skills.skill_707 then
		spells_names[707] = "shades_of_the_fallen"
		spells_costs[707] = 6
		spells_descriptions[707] = "Deals " .. tostring((7 + 2 * (skills.skill_707 + skills.skill_707 ^ 2))*(1 + magic_damage/100)) .. " arcane damage to a group of targets within the range of 2 hexes, poisoning them."
		spells_names_ingame[707] = "Shades of the Fallen"
		enchantment_cost[707] = 0
		summon[707] = 0
	end
	if skills.skill_710 then
		spells_names[710] = "storm_of_niflheim"
		spells_costs[710] = 12
		spells_descriptions[710] = "Creates a storm that deals " .. tostring((7 + skills.skill_710 ^ 2)*(1 + (magic_damage + cold_mastery)/100)) .. " cold damage to all targets in 2 hexes range and stays for " .. tostring(2 + skill_710) .. "turns. Cooldown 2 turns."
		spells_names_ingame[710] = "Storm of Niflheim"
		enchantment_cost[710] = 0
		summon[710] = 0
	end
	if skills.skill_711 then
		spells_names[711] = "hunger"
		spells_costs[711] = 0
		spells_descriptions[711] = "Heals " .. tostring(4 + 4 * skills.skill_711) .. " hitpoints after each successful blow."
		spells_names_ingame[711] = "hunger"
		enchantment_cost[711] = 1
		summon[711] = 0
	end
	if skills.skill_712 then
		spells_names[712] = "ill_luck"
		spells_costs[712] = 8
		spells_descriptions[712] = "Weakens all units in range of 2 hexes, decreasing their damage by " .. tostring(skills.skill_712) .. " and decreasing their physical resistances by " .. tostring(skills.skill_712 * 5) .. "%. Stacks with itself. Lasts for 5 turns in average"
		spells_names_ingame[712] = "Ill Luck"
		enchantment_cost[712] = 0
		summon[712] = 0
	end
	if skills.skill_713 then
		spells_names[713] = "summon_skeletal_mage"
		spells_costs[713] = 9
		spells_descriptions[713] = "Creates a skeletal mage to fight on your side. Maximum number of skeletal mages is " .. tostring(skills.skill_713) .. "."
		spells_names_ingame[713] = "Summon Skeletal Mage"
		enchantment_cost[713] = 0
		summon[713] = skills.skill_713
	end
	if skills.skill_714 then
		spells_names[714] = "rabid fumes"
		spells_costs[714] = 12
		spells_descriptions[714] = "Deals " .. tostring((3 + 3 * (skills.skill_714 + skills.skill_714 ^ 2))*(1 + magic_damage/100)) .. " arcane damage to a group of targets within the range of 5 hexes, poisoning them."
		spells_names_ingame[714] = "Rabid Fumes"
		enchantment_cost[714] = 0
		summon[714] = 0
	end
	if skills.skill_715 then
		spells_names[715] = "misfortune"
		spells_costs[715] = 10
		spells_descriptions[715] = "Weakens all units in range of 3 hexes, decreases their cold, fire and arcane resistances by " .. tostring(skills.skill_712 * 10) .. "%. Stacks with itself. Lasts for 5 turns in average"
		spells_names_ingame[715] = "Misfortune"
		enchantment_cost[715] = 0
		summon[715] = 0
	end
	if skills.skill_716 then
		spells_names[716] = "summon_spirit"
		spells_costs[716] = 9 + skills.skill_716
		spells_descriptions[716] = "Summons a ghost to fight on your side. Maximum number of ghosts is " .. tostring(skills.skill_716) .. ". Unaffected by Skeleton Mastery."
		spells_names_ingame[716] = "Summon Spirit"
		enchantment_cost[716] = 0
		summon[716] = skills.skill_716
	end
	return spells_names,spells_costs,spells_descriptions,spells_names_ingame,enchantment_cost,summon
end

function wesnoth.wml_actions.show_spells(cfg)
	-- This is the menu that shows spells list, allows casting spells and cancelling enchantments active
	local side_number = wesnoth.get_variable("side_number")
	local raw_unit = wesnoth.get_units { canrecruit=true , side=side_number }
	local unit = raw_unit[1].__cfg
	-- Identify what is on the hex being targeted to
	local target = {}
	local self = cfg.self
	local friendly = cfg.friendly
	local empty = cfg.empty
	local enemy
	local spell_chosen
	if not empty and not friendly then
		enemy = true
	end
	local mana,max_mana = wesnoth.get_mana(unit)
	if empty then
		target.x = cfg.x
		target.y = cfg.y
	else
		local raw_target = wesnoth.get_units { x=cfg.x, y=cfg.y }
		target = raw_target[1].__cfg
	end
	-- Get information about skills possessed and possible cooldowns of spells
	local skills = {}
	for i = 1,#unit do
		if unit[i][1] == "variables" then
			skills = unit[i][2]
		end
	end
	local cooldowns = {}
	for i = 1,#skills do
		if skills[i][1] == "cooldowns" then
			cooldowns = skills[i][2]
		end
	end
	-- Setup information about spells available
	local spells_names,spells_costs,spells_descriptions,spells_names_ingame,enchantment_cost,summon = wesnoth.setup_spells_descriptions(skills,skills.magic_damage)
	local result = wesnoth.synchronize_choice(
		function()
			-- Enchantments are saved in [variables] of the units they are affecting, so we need to list all units that are enchanted by our unit
			local enchantments_active = {}
			local raw_units = wesnoth.get_units({{ "filter_wml", { { "variables", {  enchanted=true }  } } }})
			if #raw_units > 0 then
				for i=1,#raw_units do
					local unit = raw_units[i].__cfg
					for j=1,#unit do
						if unit[j][1] == "variables" then
							for k=1,#unit[j][2] do
								if unit[j][2][k][1] == "enchantment" then
									if unit[j][2][k][2].caster == side_number then
										table.insert(enchantments_active, { image="misc/blank-hex.png", name=unit.name, number=unit[j][2][k][2].number, id=unit.id })
									end

								end
							end
						end
					end
				end
			end
			local enchantments_cancelled = {}	-- We need to make a list of enchantments that are going to be deleted - they can't be deleted on the run, because we're inside synchronoze_choice
			local dialog = { T.tooltip { id = "tooltip_large" }, T.helptip { id = "tooltip_large" },  maximum_height = 600, maximum_width = 800,
				T.grid { T.row { T.column { T.label { id="title" , definition="title" , label="Spells"} }} ,
					T.row { T.column { T.label { id = "gui_mana_display", label="Mana: 0/0"}}},
					T.row { T.column { T.scroll_label { id = "gui_description", label="                                                                                                                                   \n                                                                                                                                   \n                                                                                                                                   \n"}}},
					T.row { T.column { T.grid { T.row {
						T.column { T.button { id = "gui_enchantments", label = "Enchantments" , tooltip="See a list of enchantments that are draining your mana." } }
					}}}},
					T.row {	T.column { horizontal_grow = true, T.listbox { id = "gui_spell_chosen", 
						T.list_definition { T.row { T.column { horizontal_grow = true,
							T.toggle_panel { tooltip="The list of spells that can be cast on the selected location.", T.grid { T.row {
								T.column { T.image { id = "gui_spell_icon" } },
			   					T.column { T.grid { 
									T.row { T.column { horizontal_alignment = "left", T.label { id = "gui_spell_name" } }},
									T.row { T.column { horizontal_alignment = "left", T.label { id = "gui_spell_cost" } }}
								}}
							}}}
						}}}
					}}},
					T.row { T.column { T.grid { T.row {
						T.column { T.button { id = "ok", label = "Cast Spell" , tooltip="Cast the selected spell." } },
						T.column { T.button { id = "cancel", label = "Back", tooltip="Back to game." } }
					}}}}
				}}
			local function preshow()
				local function select()
					-- Just descriptions
					spell_chosen = wesnoth.get_dialog_value "gui_spell_chosen"
					wesnoth.set_dialog_active( true , "ok")
					wesnoth.set_dialog_value( spells_descriptions[spell_chosen] , "gui_description")
				end
				local function enchantments()
					-- A submenu, allowing the removal of enchantments. They are simply collected from the list of enchantments computed above, and moved to another group when cancelled
					local done = false
						while done == false do
						-- The menu is shown cyclically until all of them are removed or it is cancelled
						local enchantment_chosen
						if #enchantments_active > 0 then
							local enchantments_dialog = { T.tooltip { id = "tooltip_large" }, T.helptip { id = "tooltip_large" },  maximum_height = 600, maximum_width = 800,
								T.grid { T.row { T.column { T.label { id="title" , definition="title" , label="Enchantments"} }} ,
									T.row { T.column { T.scroll_label { id = "gui_description", label="                                                                                                                                   \n                                                                                                                                   \n                                                                                                                                   \n"}}},
									T.row {	T.column { horizontal_grow = true, T.listbox { id = "gui_enchantment_chosen", 
										T.list_definition { T.row { T.column { horizontal_grow = true,
											T.toggle_panel { tooltip="The list of enchantments that are draining your mana.", T.grid { T.row {
												T.column { T.image { id = "gui_enchantment_icon" } },
												T.column { T.image { id = "gui_enchantment_target" } },
							   					T.column { T.grid { 
													T.row { T.column { horizontal_alignment = "left", T.label { id = "gui_enchantment_name" } }},
													T.row { T.column { horizontal_alignment = "left", T.label { id = "gui_enchantment_cost" } }}
												}}
											}}}
										}}}
									}}},
								T.row { T.column { T.grid { T.row {
									T.column { T.button { id = "ok", label = "Cancel enchantment" , tooltip="Cancels the selected enchantment." } },
									T.column { T.button { id = "cancel", label = "Back", tooltip="Back to spells menu." } }
								}}}}
								}}
							local function enchantments_preshow()
								local function select()
									-- Just describing it
									enchantment_chosen = wesnoth.get_dialog_value "gui_enchantment_chosen"
									wesnoth.set_dialog_active( true , "ok")
									wesnoth.set_dialog_value( spells_descriptions[enchantments_active[enchantment_chosen].number] , "gui_description")
								end
								wesnoth.set_dialog_callback(select, "gui_enchantment_chosen")
								wesnoth.set_dialog_active( false , "ok")
								for i=1,#enchantments_active do
									-- Show the general description of all enchantments active (or not yet marked for removal by moving them to enchantments_cancelled)
									wesnoth.set_dialog_value("misc/blank-hex.png" , "gui_enchantment_chosen", i , "gui_enchantment_icon")
									wesnoth.set_dialog_value(enchantments_active[i].image , "gui_enchantment_chosen", i , "gui_enchantment_target")
									wesnoth.set_dialog_value(spells_names_ingame[enchantments_active[i].number] .. " (" .. enchantments_active[i].name .. ")"  , "gui_enchantment_chosen", i , "gui_enchantment_name")
									wesnoth.set_dialog_value("Mana cost: " .. enchantment_cost[enchantments_active[i].number]  , "gui_enchantment_chosen", i , "gui_enchantment_cost")
								end

							end
							local function enchantments_postshow()
							end
							local choice = wesnoth.show_dialog(enchantments_dialog, enchantments_preshow, enchantments_postshow)
							if choice == -1 then
								table.insert(enchantments_cancelled,enchantments_active[enchantment_chosen])
								table.remove(enchantments_active,enchantment_chosen)
							else
								done = true
							end
						else
							-- If there are no more enchantments
							done = true
							wesnoth.set_dialog_value( "You are not actively keeping an enchantment on anything." , "gui_description")
						end
					end
				end
				-- Show some other stuff
				wesnoth.set_dialog_active( false, "ok")
				wesnoth.set_dialog_callback(select, "gui_spell_chosen")
				wesnoth.set_dialog_callback(enchantments, "gui_enchantments")
				wesnoth.set_dialog_value( "Mana: " .. mana - mana % 1 .. "/" .. max_mana , "gui_mana_display")
				-- Setup descriptions for spells, only the information that will not be generated by setup_spells_descriptions, and show them if the target is valid and the caster has enough mana
				-- and no cooldown is active; it could have been done better if thought of it better by the start
				if skills.skill_104 and enemy and mana >= 4 then
					wesnoth.set_dialog_value("Spiritual Strike (" .. tostring(skills.skill_104) .. ")", "gui_spell_chosen", 104 , "gui_spell_name")
					wesnoth.set_dialog_value("attacks/magic-missile.png", "gui_spell_chosen", 104, "gui_spell_icon")
					wesnoth.set_dialog_value("Mana cost: 4", "gui_spell_chosen", 104 , "gui_spell_cost")
				end
				if skills.skill_107 and self then
					if mana >= tonumber(8 + skills.skill_107) then
						wesnoth.set_dialog_value("Spiritual Recovery (" .. tostring(skills.skill_107) .. ")", "gui_spell_chosen", 107 , "gui_spell_name")
						wesnoth.set_dialog_value("attacks/faerie-fire.png~CS(20,20,-40))", "gui_spell_chosen", 107, "gui_spell_icon")
						wesnoth.set_dialog_value("Mana cost: " .. tostring(8 + skills.skill_107), "gui_spell_chosen", 107 , "gui_spell_cost")
					end
				end
				if skills.skill_112 and empty and mana >= 4 then
					wesnoth.set_dialog_value("Ancestor Guardian (" .. tostring(skills.skill_112) .. ")", "gui_spell_chosen", 112 , "gui_spell_name")
					wesnoth.set_dialog_value("attacks/blank-attack.png~BLIT(units/stolen/Legend of the Invincibles/ancient-warrior-idle-4.png~SCALE(60,60))", "gui_spell_chosen", 112, "gui_spell_icon")
					wesnoth.set_dialog_value("Mana cost: 4", "gui_spell_chosen", 112 , "gui_spell_cost")
				end
				if skills.skill_116 and friendly and mana >= 1 then
					wesnoth.set_dialog_value("Incarnation of Odin (" .. tostring(skills.skill_116) .. ")", "gui_spell_chosen", 116 , "gui_spell_name")
					wesnoth.set_dialog_value("attacks/spirit-good.png", "gui_spell_chosen", 116, "gui_spell_icon")
					wesnoth.set_dialog_value("Mana cost: 1 per turn", "gui_spell_chosen",116 , "gui_spell_cost")
				end
				if skills.skill_203 and friendly and mana >= 1 then
					wesnoth.set_dialog_value("Flaming Weapon (" .. tostring(skills.skill_203) .. ")", "gui_spell_chosen", 203 , "gui_spell_name")
					wesnoth.set_dialog_value("attacks/sword-flaming.png", "gui_spell_chosen", 203, "gui_spell_icon")
					wesnoth.set_dialog_value("Mana cost: 1 per turn", "gui_spell_chosen",203 , "gui_spell_cost")
				end
				if skills.skill_208 and (enemy or empty) and mana >= 5 then
					wesnoth.set_dialog_value("Fireball (" .. tostring(skills.skill_208) .. ")", "gui_spell_chosen", 208 , "gui_spell_name")
					wesnoth.set_dialog_value("attacks/fireball.png", "gui_spell_chosen", 208, "gui_spell_icon")
					wesnoth.set_dialog_value("Mana cost: 5", "gui_spell_chosen",208 , "gui_spell_cost")
				end
				if skills.skill_211 and friendly and mana >= 6 then
					wesnoth.set_dialog_value("Magical Recovery (" .. tostring(skills.skill_211) .. ")", "gui_spell_chosen", 211 , "gui_spell_name")
					wesnoth.set_dialog_value("attacks/lightbeam.png", "gui_spell_chosen", 211, "gui_spell_icon")
					wesnoth.set_dialog_value("Mana cost: 6", "gui_spell_chosen", 211 , "gui_spell_cost")
				end
				if skills.skill_214 and empty and mana >= 9 then
					wesnoth.set_dialog_value("Doppelganger (" .. tostring(skills.skill_214) .. ")", "gui_spell_chosen", 214 , "gui_spell_name")
					wesnoth.set_dialog_value("attacks/doppelganger.png", "gui_spell_chosen", 214, "gui_spell_icon")
					wesnoth.set_dialog_value("Mana cost: 9", "gui_spell_chosen", 214 , "gui_spell_cost")
				end
				if skills.skill_216 and friendly and mana >= 1 then
					wesnoth.set_dialog_value("Shroud of Flame (" .. tostring(skills.skill_216) .. ")", "gui_spell_chosen", 216 , "gui_spell_name")
					wesnoth.set_dialog_value("attacks/shroud-of-flame.png", "gui_spell_chosen", 216, "gui_spell_icon")
					wesnoth.set_dialog_value("Mana cost: 1 per turn", "gui_spell_chosen",216 , "gui_spell_cost")
				end
				if skills.skill_301 and enemy and mana >= 1 then
					wesnoth.set_dialog_value("Long Range Shot (" .. tostring(skills.skill_301) .. ")", "gui_spell_chosen", 301 , "gui_spell_name")
					wesnoth.set_dialog_value("attacks/bow-elven-magic.png", "gui_spell_chosen", 301, "gui_spell_icon")
					wesnoth.set_dialog_value("Mana cost: 1", "gui_spell_chosen",301 , "gui_spell_cost")
				end
				if skills.skill_303 and friendly and mana >= 1 then
					wesnoth.set_dialog_value("Leeches (" .. tostring(skills.skill_303) .. ")", "gui_spell_chosen", 303 , "gui_spell_name")
					wesnoth.set_dialog_value("attacks/crush-wose.png", "gui_spell_chosen", 303, "gui_spell_icon")
					wesnoth.set_dialog_value("Mana cost: 1 per turn", "gui_spell_chosen",303 , "gui_spell_cost")
				end
				if skills.skill_305 and empty and mana >= 5 then
					wesnoth.set_dialog_value("Animal Follower (" .. tostring(skills.skill_305) .. ")", "gui_spell_chosen", 305 , "gui_spell_name")
					wesnoth.set_dialog_value("attacks/blank-attack.png~BLIT(units/undead/direwolf-idle-4.png~SCALE(60,60))", "gui_spell_chosen", 305, "gui_spell_icon")
					wesnoth.set_dialog_value("Mana cost: 5, then 1 per turn", "gui_spell_chosen",305 , "gui_spell_cost")
				end
				if skills.skill_311 and friendly and mana >= 3 then
					wesnoth.set_dialog_value("Synthesis (" .. tostring(skills.skill_311) .. ")", "gui_spell_chosen", 311 , "gui_spell_name")
					wesnoth.set_dialog_value("attacks/entangle.png", "gui_spell_chosen", 311, "gui_spell_icon")
					wesnoth.set_dialog_value("Mana cost: 3", "gui_spell_chosen", 311 , "gui_spell_cost")
				end
				if skills.skill_312 and (enemy or empty) and mana >= 5 then
					wesnoth.set_dialog_value("Plant Growth (" .. tostring(skills.skill_312) .. ")", "gui_spell_chosen", 312 , "gui_spell_name")
					wesnoth.set_dialog_value("attacks/wine.png", "gui_spell_chosen", 312, "gui_spell_icon")
					wesnoth.set_dialog_value("Mana cost: 5", "gui_spell_chosen", 312 , "gui_spell_cost")
				end
				if skills.skill_316 and (enemy or empty) and mana >= 11 then
					wesnoth.set_dialog_value("Earthquake (" .. tostring(skills.skill_316) .. ")", "gui_spell_chosen", 316 , "gui_spell_name")
					wesnoth.set_dialog_value("attacks/crush-wose.png", "gui_spell_chosen", 316, "gui_spell_icon")
					wesnoth.set_dialog_value("Mana cost: 11", "gui_spell_chosen", 316 , "gui_spell_cost")
				end
				if skills.skill_403 and empty and mana >= 4 then
					wesnoth.set_dialog_value("Summon Shadow (" .. tostring(skills.skill_403) .. ")", "gui_spell_chosen", 403 , "gui_spell_name")
					wesnoth.set_dialog_value("attacks/blank-attack.png~BLIT(units/undead/shadow-s-3.png~SCALE(60,60))", "gui_spell_chosen", 403, "gui_spell_icon")
					wesnoth.set_dialog_value("Mana cost: 4, then 1 per turn", "gui_spell_chosen",403 , "gui_spell_cost")
				end
				if skills.skill_406 and (enemy or empty) and mana >= 6 then
					local cooldown_lasting = false
					if cooldowns.skill_406 then
						if cooldowns.skill_406 > 0 then
							cooldown_lasting = true
						end
					end
					if cooldown_lasting == false then
						wesnoth.set_dialog_value("Poison Cloud (" .. tostring(skills.skill_406) .. ")", "gui_spell_chosen", 406 , "gui_spell_name")
						wesnoth.set_dialog_value("attacks/curse.png~GS()~CS(-50,0,-50)", "gui_spell_chosen", 406, "gui_spell_icon")
						wesnoth.set_dialog_value("Mana cost: 6", "gui_spell_chosen",406 , "gui_spell_cost")
					end
				end
				if skills.skill_412 and friendly then
					if mana >= tonumber(11 - skills.skill_412) then
						wesnoth.set_dialog_value("Invisibility (" .. tostring(skills.skill_412) .. ")", "gui_spell_chosen", 412 , "gui_spell_name")
						wesnoth.set_dialog_value("attacks/invisibility.png", "gui_spell_chosen", 412, "gui_spell_icon")
						wesnoth.set_dialog_value("Mana cost: " .. tostring(11 - skills.skill_412) .. " per turn", "gui_spell_chosen", 412 , "gui_spell_cost")
					end
				end
				if skills.skill_408 and enemy and mana >= 5 then
					wesnoth.set_dialog_value("Shadow Blast (" .. tostring(skills.skill_408) .. ")", "gui_spell_chosen", 408 , "gui_spell_name")
					wesnoth.set_dialog_value("misc/dark-missile.png", "gui_spell_chosen", 408, "gui_spell_icon")
					wesnoth.set_dialog_value("Mana cost: 5", "gui_spell_chosen", 408 , "gui_spell_cost")
				end
				if skills.skill_411 and friendly and mana >= 5 then
					wesnoth.set_dialog_value("Fleeing (" .. tostring(skills.skill_411) .. ")", "gui_spell_chosen", 411 , "gui_spell_name")
					wesnoth.set_dialog_value("misc/boots_elven.png", "gui_spell_chosen", 411, "gui_spell_icon")
					wesnoth.set_dialog_value("Mana cost: 5", "gui_spell_chosen", 411 , "gui_spell_cost")
				end
				if skills.skill_416 and (enemy or empty) and mana >= 12 then
					local cooldown_lasting = false
					if cooldowns.skill_412 then
						if cooldowns.skill_412 > 0 then
							cooldown_lasting = true
						end
					end
					if cooldown_lasting == false then
						wesnoth.set_dialog_value("Shadow Explosion (" .. tostring(skills.skill_416) .. ")", "gui_spell_chosen", 416 , "gui_spell_name")
						wesnoth.set_dialog_value("attacks/noctum.png", "gui_spell_chosen", 416, "gui_spell_icon")
						wesnoth.set_dialog_value("Mana cost: 12", "gui_spell_chosen",416 , "gui_spell_cost")
					end
				end
				if skills.skill_502 and friendly and mana >= 2 then
					wesnoth.set_dialog_value("Divine Might (" .. tostring(skills.skill_502) .. ")", "gui_spell_chosen", 502 , "gui_spell_name")
					wesnoth.set_dialog_value("attacks/fist.png.png", "gui_spell_chosen", 502, "gui_spell_icon")
					wesnoth.set_dialog_value("Mana cost: 2 per turn", "gui_spell_chosen",502 , "gui_spell_cost")
				end
				if skills.skill_503 and enemy and mana >= 6 then
					wesnoth.set_dialog_value("Lightbeam (" .. tostring(skills.skill_503) .. ")", "gui_spell_chosen", 503 , "gui_spell_name")
					wesnoth.set_dialog_value("misc/lightbeam.png", "gui_spell_chosen", 503, "gui_spell_icon")
					wesnoth.set_dialog_value("Mana cost: 6", "gui_spell_chosen",503 , "gui_spell_cost")
				end
				if skills.skill_504 and friendly and mana >= 9 then
					wesnoth.set_dialog_value("Heal (" .. tostring(skills.skill_504) .. ")", "gui_spell_chosen", 504 , "gui_spell_name")
					wesnoth.set_dialog_value("misc/lightbeam.png~CS(-20,-20,20)", "gui_spell_chosen", 504, "gui_spell_icon")
					wesnoth.set_dialog_value("Mana cost: 9", "gui_spell_chosen",504 , "gui_spell_cost")
				end
				if skills.skill_507 and friendly and mana >= 1 then
					wesnoth.set_dialog_value("Holy Armor (" .. tostring(skills.skill_507) .. ")", "gui_spell_chosen", 507 , "gui_spell_name")
					wesnoth.set_dialog_value("icons/steel_armor.png", "gui_spell_chosen", 507, "gui_spell_icon")
					wesnoth.set_dialog_value("Mana cost: 1 per turn", "gui_spell_chosen",507 , "gui_spell_cost")
				end
				if skills.skill_508 and (enemy or empty) and mana >= 11 then
					wesnoth.set_dialog_value("Divine Blast (" .. tostring(skills.skill_508) .. ")", "gui_spell_chosen", 508 , "gui_spell_name")
					wesnoth.set_dialog_value("attacks/faerie-fire.png~CS(10,10,40)", "gui_spell_chosen", 508, "gui_spell_icon")
					wesnoth.set_dialog_value("Mana cost: 11", "gui_spell_chosen",508 , "gui_spell_cost")
				end
				if skills.skill_509 and friendly and mana >= 1 then
					wesnoth.set_dialog_value("Magical Mirror (" .. tostring(skills.skill_509) .. ")", "gui_spell_chosen", 509 , "gui_spell_name")
					wesnoth.set_dialog_value("attacks/curse.png~CS(0,-50,-50)", "gui_spell_chosen", 509, "gui_spell_icon")
					wesnoth.set_dialog_value("Mana cost: 1 per turn", "gui_spell_chosen",509 , "gui_spell_cost")
				end
				if skills.skill_510 and (enemy or empty) and mana >= 12 then
					wesnoth.set_dialog_value("Searing Light (" .. tostring(skills.skill_510) .. ")", "gui_spell_chosen", 510 , "gui_spell_name")
					wesnoth.set_dialog_value("attacks/faerie-fire.png~CS(20,-30,-80)", "gui_spell_chosen", 510, "gui_spell_icon")
					wesnoth.set_dialog_value("Mana cost: 12", "gui_spell_chosen",510 , "gui_spell_cost")
				end
				if skills.skill_511 and friendly and mana >= 2 then
					wesnoth.set_dialog_value("Blessing (" .. tostring(skills.skill_511) .. ")", "gui_spell_chosen", 511 , "gui_spell_name")
					wesnoth.set_dialog_value("attacks/lightbeam.png", "gui_spell_chosen", 511, "gui_spell_icon")
					wesnoth.set_dialog_value("Mana cost: 2 per turn", "gui_spell_chosen",511 , "gui_spell_cost")
				end
				if skills.skill_512 and empty and mana >= 10 then
					wesnoth.set_dialog_value("Summon Messenger (" .. tostring(skills.skill_512) .. ")", "gui_spell_chosen", 512 , "gui_spell_name")
					wesnoth.set_dialog_value("attacks/blank-attack.png~BLIT(units/stolen/Legend of the Invincibles/celestial+female.png~SCALE(60,60))", "gui_spell_chosen", 512, "gui_spell_icon")
					wesnoth.set_dialog_value("Mana cost: 10", "gui_spell_chosen", 512 , "gui_spell_cost")
				end
				if skills.skill_514 and (enemy or empty) and mana >= 14 then
					wesnoth.set_dialog_value("Divine Wrath (" .. tostring(skills.skill_514) .. ")", "gui_spell_chosen", 514 , "gui_spell_name")
					wesnoth.set_dialog_value("attacks/fire-blast.png~GS()", "gui_spell_chosen", 514, "gui_spell_icon")
					wesnoth.set_dialog_value("Mana cost: 14", "gui_spell_chosen",514 , "gui_spell_cost")
				end
				if skills.skill_516 and friendly and mana >= 12 then
					wesnoth.set_dialog_value("Restoration (" .. tostring(skills.skill_516) .. ")", "gui_spell_chosen", 516 , "gui_spell_name")
					wesnoth.set_dialog_value("attacks/lightbeam.png", "gui_spell_chosen", 516, "gui_spell_icon")
					wesnoth.set_dialog_value("Mana cost: 12", "gui_spell_chosen", 516 , "gui_spell_cost")
				end
				if skills.skill_617 and (enemy or empty) and mana >= 12 then
					local cooldown_lasting = false
					if cooldowns.skill_517 then
						if cooldowns.skill_517 > 0 then
							cooldown_lasting = true
						end
					end
					if cooldown_lasting == false then
						wesnoth.set_dialog_value("Armageddon (" .. tostring(skills.skill_517) .. ")", "gui_spell_chosen", 517 , "gui_spell_name")
						wesnoth.set_dialog_value("attacks/firestorm.png", "gui_spell_chosen", 517, "gui_spell_icon")
						wesnoth.set_dialog_value("Mana cost: 12", "gui_spell_chosen",517 , "gui_spell_cost")
					end
				end
				if skills.skill_601 and friendly and mana >= 2 then
					wesnoth.set_dialog_value("Steel Skin (" .. tostring(skills.skill_601) .. ")", "gui_spell_chosen", 601 , "gui_spell_name")
					wesnoth.set_dialog_value("icons/cuirass_muscled.png", "gui_spell_chosen", 601, "gui_spell_icon")
					wesnoth.set_dialog_value("Mana cost: 2 per turn", "gui_spell_chosen",601 , "gui_spell_cost")
				end
				if skills.skill_603 and enemy and mana >= 5 then
					wesnoth.set_dialog_value("Freezing Bolt (" .. tostring(skills.skill_603) .. ")", "gui_spell_chosen", 603 , "gui_spell_name")
					wesnoth.set_dialog_value("attacks/iceball.png", "gui_spell_chosen", 603, "gui_spell_icon")
					wesnoth.set_dialog_value("Mana cost: 5", "gui_spell_chosen", 603 , "gui_spell_cost")
				end
				if skills.skill_604 and enemy and mana >= 6 then
					wesnoth.set_dialog_value("Inferno (" .. tostring(skills.skill_604) .. ")", "gui_spell_chosen", 604 , "gui_spell_name")
					wesnoth.set_dialog_value("attacks/fire-blast.png", "gui_spell_chosen", 604, "gui_spell_icon")
					wesnoth.set_dialog_value("Mana cost: 6", "gui_spell_chosen", 604 , "gui_spell_cost")
				end
				if skills.skill_607 and empty and mana >= 6 then
					wesnoth.set_dialog_value("Create Golem (" .. tostring(skills.skill_607) .. ")", "gui_spell_chosen", 607 , "gui_spell_name")
					wesnoth.set_dialog_value("attacks/blank-attack.png~BLIT(units/stolen/Era of Magic/elemental-earth.png~SCALE(60,60))", "gui_spell_chosen", 607, "gui_spell_icon")
					wesnoth.set_dialog_value("Mana cost: 6, 1 per turn", "gui_spell_chosen", 607 , "gui_spell_cost")
				end
				if skills.skill_608 and (enemy or empty) and mana >= 11 then
					wesnoth.set_dialog_value("Grimcold Blast (" .. tostring(skills.skill_608) .. ")", "gui_spell_chosen", 608 , "gui_spell_name")
					wesnoth.set_dialog_value("attacks/iceball.png~CS(-50,0,-50)", "gui_spell_chosen", 608, "gui_spell_icon")
					wesnoth.set_dialog_value("Mana cost: 11", "gui_spell_chosen", 608 , "gui_spell_cost")
				end
				if skills.skill_611 and enemy then
					if mana >= tonumber(16 - 2 * skills.skill_611) then
						wesnoth.set_dialog_value("Chilling Beam (" .. tostring(skills.skill_611) .. ")", "gui_spell_chosen", 611 , "gui_spell_name")
						wesnoth.set_dialog_value("attacks/faerie-fire.png~CS(20,20,-40)", "gui_spell_chosen", 611, "gui_spell_icon")
						wesnoth.set_dialog_value("Mana cost: " .. tostring(8 + skills.skill_611), "gui_spell_chosen", 611 , "gui_spell_cost")
					end
				end
				if skills.skill_613 and (enemy or empty) and mana >= 12 then
					local cooldown_lasting = false
					if cooldowns.skill_613 then
						if cooldowns.skill_613 > 0 then
							cooldown_lasting = true
						end
					end
					if cooldown_lasting == false then
						wesnoth.set_dialog_value("Meteor Storm (" .. tostring(skills.skill_613) .. ")", "gui_spell_chosen", 613 , "gui_spell_name")
						wesnoth.set_dialog_value("attacks/firestorm.png", "gui_spell_chosen", 613, "gui_spell_icon")
						wesnoth.set_dialog_value("Mana cost: 12", "gui_spell_chosen",613 , "gui_spell_cost")
					end
				end
				if skills.skill_615 and friendly and mana >= 1 then
					wesnoth.set_dialog_value("Freezing Armor (" .. tostring(skills.skill_615) .. ")", "gui_spell_chosen", 615 , "gui_spell_name")
					wesnoth.set_dialog_value("icons/cuirass_muscled.png~CS(-90,-90,20)", "gui_spell_chosen", 615, "gui_spell_icon")
					wesnoth.set_dialog_value("Mana cost: 1 per turn", "gui_spell_chosen",615 , "gui_spell_cost")
				end
				if skills.skill_702 and empty and mana >= 7 then
					wesnoth.set_dialog_value("Summon Skeleton (" .. tostring(skills.skill_702) .. ")", "gui_spell_chosen", 702 , "gui_spell_name")
					wesnoth.set_dialog_value("attacks/blank-attack.png~BLIT(units/undead-skeletal/skeleton-attack-2.png~(magenta>black)~SCALE(60,60))", "gui_spell_chosen", 702, "gui_spell_icon")
					wesnoth.set_dialog_value("Mana cost: 7", "gui_spell_chosen", 702 , "gui_spell_cost")
				end
				if skills.skill_703 and (enemy or empty) and mana >= 7 then
					if not (skills.skill_703 == 1 and empty) then
						wesnoth.set_dialog_value("Dark Blast (" .. tostring(skills.skill_703) .. ")", "gui_spell_chosen", 703 , "gui_spell_name")
						wesnoth.set_dialog_value("misc/dark-missile.png", "gui_spell_chosen", 703, "gui_spell_icon")
						wesnoth.set_dialog_value("Mana cost: 6", "gui_spell_chosen", 703 , "gui_spell_cost")
					end
				end
				if skills.skill_704 and friendly and mana >= 1 then
					wesnoth.set_dialog_value("Foul Cloak (" .. tostring(skills.skill_704) .. ")", "gui_spell_chosen", 704 , "gui_spell_name")
					wesnoth.set_dialog_value("icons/dress_silk_green.png~GS~CS(-100,0,-100)", "gui_spell_chosen", 704, "gui_spell_icon")
					wesnoth.set_dialog_value("Mana cost: 1 per turn", "gui_spell_chosen", 704 , "gui_spell_cost")
				end
				if skills.skill_705 and (enemy or empty) and mana >= 10 then
					wesnoth.set_dialog_value("Freezing Wave (" .. tostring(skills.skill_705) .. ")", "gui_spell_chosen", 705 , "gui_spell_name")
					wesnoth.set_dialog_value("attacks/iceball.png", "gui_spell_chosen", 705, "gui_spell_icon")
					wesnoth.set_dialog_value("Mana cost: 10", "gui_spell_chosen", 705 , "gui_spell_cost")
				end
				if skills.skill_706 and empty and mana >= 8 then
					wesnoth.set_dialog_value("Summon Skeletal Archer (" .. tostring(skills.skill_706) .. ")", "gui_spell_chosen", 706 , "gui_spell_name")
					wesnoth.set_dialog_value("attacks/blank-attack.png~BLIT(units/undead-skeletal/archer-bow-attack-1.png~(magenta>black)~SCALE(60,60))", "gui_spell_chosen", 706, "gui_spell_icon")
					wesnoth.set_dialog_value("Mana cost: 8", "gui_spell_chosen", 706 , "gui_spell_cost")
				end
				if skills.skill_707 and (enemy or empty) and mana >= 6 then
					wesnoth.set_dialog_value("Shades of the Fallen (" .. tostring(skills.skill_707) .. ")", "gui_spell_chosen", 707 , "gui_spell_name")
					wesnoth.set_dialog_value("attacks/dark-missile.png~GS~CS(20,-100,-100)", "gui_spell_chosen", 707, "gui_spell_icon")
					wesnoth.set_dialog_value("Mana cost: 6", "gui_spell_chosen", 707 , "gui_spell_cost")
				end
				if skills.skill_710 and (enemy or empty) and mana >= 12 then
					local cooldown_lasting = false
					if cooldowns.skill_710 then
						if cooldowns.skill_710 > 0 then
							cooldown_lasting = true
						end
					end
					if cooldown_lasting == false then
						wesnoth.set_dialog_value("Storm of Niflheim (" .. tostring(skills.skill_710) .. ")", "gui_spell_chosen", 710 , "gui_spell_name")
						wesnoth.set_dialog_value("blizzard.png", "gui_spell_chosen", 710, "gui_spell_icon")
						wesnoth.set_dialog_value("Mana cost: 12", "gui_spell_chosen",710 , "gui_spell_cost")
					end
				end
				if skills.skill_711 and friendly and mana >= 1 then
					wesnoth.set_dialog_value("Hunger (" .. tostring(skills.skill_711) .. ")", "gui_spell_chosen", 711 , "gui_spell_name")
					wesnoth.set_dialog_value("attacks/dark-missile.png~GS~CS(-100,-200,-150)", "gui_spell_chosen", 711, "gui_spell_icon")
					wesnoth.set_dialog_value("Mana cost: 1 per turn", "gui_spell_chosen", 711 , "gui_spell_cost")
				end
				if skills.skill_712 and friendly and mana >= 8 then
					wesnoth.set_dialog_value("Ill Luck (" .. tostring(skills.skill_712) .. ")", "gui_spell_chosen", 712 , "gui_spell_name")
					wesnoth.set_dialog_value("attacks/curse.png~GS", "gui_spell_chosen", 712, "gui_spell_icon")
					wesnoth.set_dialog_value("Mana cost: 8", "gui_spell_chosen", 712 , "gui_spell_cost")
				end
				if skills.skill_713 and empty and mana >= 9 then
					wesnoth.set_dialog_value("Summon Skeletal Mage (" .. tostring(skills.skill_713) .. ")", "gui_spell_chosen", 713 , "gui_spell_name")
					wesnoth.set_dialog_value("attacks/blank-attack.png~BLIT(units/undead/mage.png~(magenta>black)~SCALE(60,60))", "gui_spell_chosen", 713, "gui_spell_icon")
					wesnoth.set_dialog_value("Mana cost: 9", "gui_spell_chosen", 713 , "gui_spell_cost")
				end
				if skills.skill_714 and (empty or enemy) and mana >= 12 then
					wesnoth.set_dialog_value("Rabid Fumes (" .. tostring(skills.skill_714) .. ")", "gui_spell_chosen", 714 , "gui_spell_name")
					wesnoth.set_dialog_value("attacks/bane.png", "gui_spell_chosen", 714, "gui_spell_icon")
					wesnoth.set_dialog_value("Mana cost: 12", "gui_spell_chosen", 714 , "gui_spell_cost")
				end
				if skills.skill_715 and friendly and mana >= 10 then
					wesnoth.set_dialog_value("Misfortune (" .. tostring(skills.skill_715) .. ")", "gui_spell_chosen", 715 , "gui_spell_name")
					wesnoth.set_dialog_value("attacks/curse.png", "gui_spell_chosen", 715, "gui_spell_icon")
					wesnoth.set_dialog_value("Mana cost: 10", "gui_spell_chosen", 715 , "gui_spell_cost")
				end
				if skills.skill_716 and empty then
					if mana >= tonumber(9 + skills.skill_716) then
						wesnoth.set_dialog_value("Summon Spirit (" .. tostring(skills.skill_716) .. ")", "gui_spell_chosen", 716 , "gui_spell_name")
						wesnoth.set_dialog_value("attacks/blank-attack.png~BLIT(units/undead/spectre.png~(magenta>black)~SCALE(60,60))", "gui_spell_chosen", 716, "gui_spell_icon")
						wesnoth.set_dialog_value("Mana cost: " .. tostring(9 + skills.skill_716) , "gui_spell_chosen", 716 , "gui_spell_cost")
					end
				end
			end

			local function postshow()
			end

			local chose = wesnoth.show_dialog(dialog, preshow, postshow)
			-- The information about enchantments cancelled contains two important keys, id of the target and the number of the enchantment, and we must convert it to string, because no tables can be
			-- returned by synchronize_choice, so they are concantated into a string, and then parsed, there is always the id followed by id for each.
			local cancelling_table = {}
			for j = 1,#enchantments_cancelled do
				cancelling_table[#cancelling_table+1] = enchantments_cancelled[j].id
				cancelling_table[#cancelling_table+1] = enchantments_cancelled[j].number
			end
			return {chose = chose, spell_chosen = spell_chosen, enchantments_cancelled = table.concat(cancelling_table,",")}
		end
	)
	-- Parse the values returned back into a table
	local enchantments_cancelled = {}
	local id_not_number = true
	for j in string.gmatch( result.enchantments_cancelled , "[^%s,][^,]*") do
		if id_not_number == true then
			table.insert(enchantments_cancelled, {id = j})
			id_not_number = false
		else
			enchantments_cancelled[#enchantments_cancelled].number = tonumber(j)
			id_not_number = true
		end
	end
	-- Cancelling all enchantments that are on the list
	for a = 1,#enchantments_cancelled do
		-- Find the target
		local raw_target = wesnoth.get_units { id=enchantments_cancelled[a].id }
		local target = raw_target[1].__cfg
		-- Remove the enchantment from the list of its enchantments
		for i = 1,#target do
			if target[i][1] == "variables" then
				for j=1,#target[i][2] do
					if target[i][2][j][1] == "enchantment" then
						if target[i][2][j][2].number == enchantments_cancelled[a].number then
							target[i][2][spells_names[enchantments_cancelled[a].number]] = nil
							target[i][2][spells_names[enchantments_cancelled[a].number].. "_level"] = nil
							table.remove(target[i][2],j)
							break
						end
					end
				end
				-- Check if it has more enchantments - the mark that it is enchanted should be removed if has no enchantments anymore
				local enchanted = false
				for j=1,#target[i][2] do
					if target[i][2][j][1] == "enchantment" then
						enchanted = true
					end
				end
				if enchanted == false then
					target[i][2].enchanted = nil
				end
			end
		end
		wesnoth.put_unit(target)
		if unit.id == target.id then
			unit = target
		end
	end
	-- If a spell was chosen, cast it
	if result.spell_chosen and result.chose == -1 then
		-- The spell costs one attack and some mana
		unit.attacks_left = unit.attacks_left - 1
		for i = 1,#unit do
			if unit[i][1] == "variables" then
				unit[i][2].mana = unit[i][2].mana - spells_costs[result.spell_chosen]
			end
		end
		unit = wesnoth.display_mana(unit)
		wesnoth.put_unit(unit)
		-- Spells are normally WML events fired by lua, but enchantments have to be handled differently
		if enchantment_cost[result.spell_chosen] > 0 and summon[result.spell_chosen] == 0 then
			for i=1,#target do
				-- Add the enchantment
				if target[i][1] == "variables" then
					target[i][2].enchanted = true
					local function check_for_enchantments(skill)
						if result.spell_chosen == skill then
							if target[i][2][spells_names[skill]]== true then
								-- It is possible that the unit is already enchanted by somebody else, overwrite it only if the level is higher, don't do anything otherwise
								if target[i][2][spells_names[skill] .. "_level"] < skills["skill_" .. skill] then
									target[i][2][spells_names[skill] .. "_level"] = skills["skill_" .. skill]
									for j=1,#target do
										if target[j][1] == "enchantment" then
											if target[j][2].name == spells_names[skill] then
												target[j][2].caster = side_number
											end
										end
									end
								end
							else
								target[i][2][spells_names[skill]] = true
								target[i][2][spells_names[skill] .. "_level"] = skills["skill_" .. skill]
								if skill == 704 and skills.skill_717 then
									-- Foul cloak is affected by a poison-improving passive, so it has to be handled specially
									target[i][2]["foul_cloak_level"] = skills.skill_704 + skills.skill_717
								end
								table.insert( target[i][2] , { "enchantment" , { name=spells_names[skill], caster=side_number, cost=enchantment_cost[skill], number=skill } } )
							end
						end
					end
					check_for_enchantments(116)
					check_for_enchantments(203)
					check_for_enchantments(216)
					check_for_enchantments(303)
					check_for_enchantments(412)
					check_for_enchantments(502)
					check_for_enchantments(507)
					check_for_enchantments(509)
					check_for_enchantments(511)
					check_for_enchantments(601)
					check_for_enchantments(704)
					check_for_enchantments(711)
				end
			end
			wesnoth.put_unit(target)
		else
			-- If it's not an enchantment, we simply fire the spell's event
			wesnoth.fire_event(spells_names[result.spell_chosen],unit.x,unit.y,target.x,target.y)
		end
		-- Units get one move after attacking, so it should work also for spells
		wesnoth.fire_event("attack end",unit.x,unit.y,target.x,target.y)
	end
end
