-- This is the first file loaded, and it serves to load WML data that will be used by the functions (it's contained in a unit_type, toplevel lua does not accept arguments, so this trick is necessary)

helper = wesnoth.require "lua/helper.lua"
T = helper.set_wml_tag_metatable {}
V = helper.set_wml_var_metatable {}
_ = wesnoth.textdomain "wesnoth-world_of_wesnoth"

-- Load the unit containing the data, and save its contents into lua variables that will be read a lot
raw_data = wesnoth.unit_types.DataLoader.__cfg
races = raw_data[1][2][1][2]
classes = raw_data[1][2][2][2]
uniques = raw_data[1][2][3][2]
base_items = raw_data[1][2][4][2]
prefixes = raw_data[1][2][5][2]
suffixes = raw_data[1][2][6][2]

-- Load all lua files that are to be used; if you are trying to study this code, it is strongly recommended to start with utils.lua and then character,lua, it contains a lot of basic information
wesnoth.dofile '~add-ons/World_of_Wesnoth/lua/utils.lua'		-- Contains some basic functions that will be used a lot, some WML tags that don't belong to any other cathegory and some utility functions
wesnoth.dofile '~add-ons/World_of_Wesnoth/lua/graphics.lua'		-- Contains functions regarding visual representation of things
wesnoth.dofile '~add-ons/World_of_Wesnoth/lua/advancing.lua'		-- Deals with the wesnoth.level_up function, that makes the unit advance a level
wesnoth.dofile '~add-ons/World_of_Wesnoth/lua/character.lua'		-- Deals with generating the unit's properties from items and skills, also a menu that shows the properties of the unit, exports and imports characters
wesnoth.dofile '~add-ons/World_of_Wesnoth/lua/character_creation.lua'	-- Deals with the first menu the playes sees, the generation of character
wesnoth.dofile '~add-ons/World_of_Wesnoth/lua/items.lua'		-- Contains all kinds of item-related functions, like describing them, manipulating inventory, trading window or generating random drops
wesnoth.dofile '~add-ons/World_of_Wesnoth/lua/spells.lua'		-- Deals with the menu of casting spells and manipulating enchantments
wesnoth.dofile '~add-ons/World_of_Wesnoth/lua/unit_spawning.lua'	-- Contains definitions of WML tags useful to populate levels with monsters without having to use macros
